; ------------------------------------------------------------------------------------------------------------------------
; --------------- OPSI LEXING --------------------------------------------------------------------------------------------
; ------------------------------------------------------------------------------------------------------------------------

;OPSI Language defintions
Global $file_types = "Scripts (*.ins;*.opsiinc)"

; ------------------------------------------------------------------------------------------------------------------------
; --------------- LANGUAGE PARAMS ----------------------------------------------------------------------------------------
; ------------------------------------------------------------------------------------------------------------------------

; prepare keywords
Global $keywords = 'if endif else not set defvar defstringlist sub and or in for do'
Global $fuwords = 'localadmin comment message fileexists fileexists64 fileexists32 fileexistsSysNative hasminimumspace opsiLicenseManagementEnabled XMLAddNamespace XMLRemoveNamespace runningAsAdmin isLoginScript scriptWasExecutedBefore contains isNumber getLastExitCode gethostsaddr gethostsname GetUserSID getmultiszfromfile getntversion getos GetMSVersionInfo GetProductProperty getregistrystringvalue getregistrystringvalue64 getregistrystringvalue32 getregistrystringvalueSysNative GetSystemtype getValue getvaluefrominifile envvar errorsoccuredsincemark extractfilepath regstring Trim HexStrToDecStr DecStrToHexStr getLogLevel lower LangCodeByHex CompareDotSeparatedStrings CompareDotSeparatedNumbers base64EncodeStr base64DecodeStr Convert2JsonStr GetLoggedInUser GetUsercontext GetScriptMode getValueBySeparator unquote readVersionFromProfile stringReplace GetMyIpByTarget getIpByName getDiffTimeSec SidToName strLength strPos strPart calculate getLastServiceErrorMessage getLastServiceErrorClass demandLicenseKey freeLicense createstringlist composestring getLocaleInfoMap getFileInfoMap getMSVersionMap getoutstreamfromsection getreturnlistfromsection getsublist loadtextfile loadunicodetextfile retrievesection reverse splitstring splitstringonwhitespace takestring takeFirstStringContaining getlistContaining count addtolist addlisttolist getSectionNames getProcessList getProductPropertyList getRegistryKeyList32 getRegistryKeyList64 getRegistryKeyListSysnative getRegistryVarList32 getRegistryVarList64 getRegistryVarListSysnative getProductMap getProfilesDirList GetRegistryVarMap32 GetRegistryVarMap64 GetRegistryVarMapSysNative checktargetpath copy delete del sourcepath delete_element delete_subfolder deletelement end_link icon_file icon_index name set_basefolder set_link set_subfolder working_dir alias driver add addnew change del delsec replace delhost delalias setaddr setalias addline append_file appendline Set_Mozilla_Pref AddStringListElement_To_Mozilla_Pref advanceline deletealllines_startingwith deletetheline findline findline_containing findline_startingwith gotobottom gototop insertline linebeginning_existsin lineexistsin savetofile sorted subtract_file deletekey flushkey openkey reconstructfrom regedit registry supp SaveValueToFile all_childelements_with documentroot create_when_node_not_existing error_when_no_node_existing error_when_nodecount_greater_1 attributenames attributes counting elementnames elements text return warning_when_no_node_existing warning_when_nodecount_greater_1 opennodeset exitwindows immediatelogout immediatereboot isfatalerror pause reboot showbitmap showmessagefile sleepSeconds ChangeDirectory NormalizeWinst IconizeWinst RestoreWinst BlockInput addattribute addreg addtext attribute attributes_strict deleteattribute deletevar elementname end killtask logerror logwarning markerrornumber markTime diffTime parameters randomstr setattribute setcomment setname settext stop target text'
Global $reswords = 'runasloggedonadmin 64bit 32bit sysnative setOutputLevel SetLogLevel ExitOnError ScriptErrorMessages TraceMode StayOnTop requiredWinstVersion SetUsercontext saveVersionToProfile includelog include_insert include_append FatalOnSyntaxError SetSkinDirectory SetConfidential'
Global $constwords = 'desktop sendto startmenu startup programs desktopdirectory common_startmenu common_programscommon_startup common_desktopdirectory False True on off'
Global $additional_1 = ''
Global $additional_2 = ''
Global $syssections = 'Initital Actions ProfileActions sub registry patchtextfile patches patchhosts winbatch dosinanicon dosbatch shellinanicon shellbatch files LinkFolder OpsiServiceCall OpsiServiceHashList Execwith ExecPython LdapSearch xmlpatch'
Global $blockcomments = '#cs #ce #comment-begin #comment-end' ; always paired like #comment-begin #comment-end, because they get added to $arFolding!!!!
Global $operator = '+ - * & ^ = < > , \ /'
Global $braces = '{ } ( )' ; "normal" braces, no section marker
Global $charsforvariables = 'abcdefghijklmnopqrstuvwXYZABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789_'
Global $specialleadingwordchars = '#' ; this will be added to standard Scintilla character set to support word finding, i. e. #region
; special control chars
Global $has_sections = True ; if you set this to false, $syssections will be a normal "special word" array, no check for $sect_open or $sect_close
Global $sect_open = '[' ; open section character - you can set it to something else to mark other things
Global $sect_close = ']' ; close section character - you can set it to something else to mark other things
Global $quot = Chr(34) ; quote char (Chr() is needed, as '"' doesn't work!!!)
Global $apostrophe = Chr(39) ; apostrophe char (Chr() is needed, as "'" doesn't work!!!)
Global $comment_single_line = ';' ; first char in a single line comment
Global $var_mark = "$" ; variable marker
Global $var_end_mark = "$" ; variable end marker
Global $var_nested = True ; colourise nested vars in strings
Global $sysvar_mark = "%" ; system variable marker
Global $sysvar_end_mark = "%" ; system variable end marker
Global $sysvar_nested = True ; colourise nested sysvars in strings
Global $constwords_mark = "" ; constants marker
Global $constwords_end_mark = "" ; constants end marker
Global $constwords_nested = false ; colourise nested constant words

; Array description $arFolding
; -> (0) react on keyword
; -> (1) with special eol condition (Optional),
; -> (2) change level depth for current
; -> (3) and next line by array value,
; -> (4) has corresponding opening/closing tags true/false
; positive/negative values for (2) and (3) increase/decrease the depth
; (4)=if there is no closing tag, expect as kind of main section, then don't increase currentLevel,
; but set currentLevel to fix array value

; a very special combination is (2) = -1 and (3) = 0 -> this marks a middle keyword in a structure like if...ELSE...endif
; if you recalculate folding with ELSE position as starting position, it decreases it's own structural position a second, third,... time
; because the reference to the preceeding if isn't given
; -> has to be cared for in foldIt specially

#cs folding configuration for  la autoit
	Global $arFolding[23][5] = [ _
	["if","then",0,1,true], _
	["for","",0,1,true], _
	["do","",0,1,true], _
	["func","",0,1,true], _
	["while","",0,1,true], _
	["with","",0,1,true], _
	["#region","",0,1,true], _
	["select","",0,2,true], _
	["switch","",0,2,true], _
	["endfunc","",-1,-1,true], _
	["endif","",-1,-1,true], _
	["next","",-1,-1,true], _
	["until","",-1,-1,true], _
	["endwidth","",-1,-1,true], _
	["wend","",-1,-1,true], _
	["case","",-1,0,true], _
	["else","",-1,0,true], _
	["elseif","",-1,0,true], _
	["endselect","",-2,-2,true], _
	["endswitch","",-2,-2,true], _
	["#endregion","",0,-1,true] _
	]
#ce

; folding configuration for opsi
Global $fold_lang_elements = 5
Global $include_commentline = True
Global $include_sections = True

Global $arFoldingLang[$fold_lang_elements][5] = [ _
	["if", "", 0, 1, True], _ 
	["else", "", -1, 0, True], _ 
	["endif", "", 0, -1, True], _ 
	[$sect_open, "", 0, 1, False], _ 
	[$comment_single_line, "", 0, 1, False] _ 
	]

; ------------------------------------------------------------------------------------------------------------------------
; --------------- STYLER PARAMS ----------------------------------------------------------------------------------------
; ------------------------------------------------------------------------------------------------------------------------

; set startup defaults
Global $default_fold = False
Global $default_fold_compact = False
Global $default_fold_comment = False
Global $default_highlight = False

;Sci_StyleSet($hWnd_SciLexer, $SCE_STYLE_KEYWORDS, 0x89001F, -1, 1) ; keywords
;Sci_StyleSet($hWnd_SciLexer, $SCE_STYLE_SYSVARS, 0xBB00BB, -1, 1, 1) ; system variables
;Sci_StyleSet($hWnd_SciLexer, $SCE_STYLE_OPERATORS, 0x0000FF) ; operators, etc.
;Sci_StyleSet($hWnd_SciLexer, $SCE_STYLE_COMMENTLINE, 0x3A66CD) ; skript comment
;Sci_StyleSet($hWnd_SciLexer, $SCE_STYLE_COMMENTBLOCK, 0x009966) ; skript block comment  (light green)
;Sci_StyleSet($hWnd_SciLexer, $SCE_STYLE_TEXTINQUOTE, 0xE430E6) ; text in '' or ""
;Sci_StyleSet($hWnd_SciLexer, $SCE_STYLE_RESWORDS, 0xFF8000, -1, 0) ; reserved words
;Sci_StyleSet($hWnd_SciLexer, $SCE_STYLE_VARIABLES, 0x009000, -1, 1) ; variables
;Sci_StyleSet($hWnd_SciLexer, $SCE_STYLE_FUNCTIONS, 0xB25F36, -1, 0, 1) ; functions
;Sci_StyleSet($hWnd_SciLexer, $SCE_STYLE_SECTIONS, 0x000000, -1, 1, 1) ; sections
;Sci_StyleSet($hWnd_SciLexer, $SCE_STYLE_SYSSECTIONS, 0x0000FF, -1, 0, 1) ; sections
;Sci_StyleSet($hWnd_SciLexer, $SCE_STYLE_CONST, 0x0080FF, -1, 1, 1) ; special constants (orange)

#cs
			0x000000, _ ; Text color (BGR)!!!
			0xFFDDFF, _ ; Background color (BGR)!!!!
			1, _ ; Bold
			0, _ ; Italic
			0, _ ; Underline
			 - 1, _ ; Fontname
			 - 1, _ ; Fontsize
			0) ; Hotspot
#ce

Global $arStyle[18][8] = [ _
	[$STYLE_DEFAULT, 			0x000000, 0xFFFFFF, 0, 0, 0, "Courier New", 10], _ 	; DEFAULT STYLE <- has ALWAYS to be the first in array!
	[$SCE_STYLE_KEYWORDS, 		0x89001F, -1,  1,  0, -1, -1, -1], _ 				; keywords
	[$SCE_STYLE_SYSVARS, 		0xBB00BB, -1,  1,  1, -1, -1, -1], _				; system variables
	[$SCE_STYLE_OPERATORS, 		0x0000FF, -1, -1, -1, -1, -1, -1], _				; operators, etc.
	[$SCE_STYLE_COMMENTLINE, 	0x3A66CD, -1, -1, -1, -1, -1, -1], _				; skript comment
	[$SCE_STYLE_COMMENTBLOCK, 	0x009966, -1, -1, -1, -1, -1, -1], _				; skript block comment
	[$SCE_STYLE_TEXTINQUOTE, 	0xE430E6, -1, 1, -1, -1, -1, -1], _				; text in '' or ""
	[$SCE_STYLE_RESWORDS,	 	0xFF8000, -1,  0,  0, -1, -1, -1], _				; reserved words
	[$SCE_STYLE_VARIABLES, 		0x009000, -1,  1,  0, -1, -1, -1], _				; variables
	[$SCE_STYLE_FUNCTIONS,		0xB25F36, -1,  0,  0, -1, -1, -1], _				; functions
	[$SCE_STYLE_SECTIONS,		0x000000, -1,  1,  1, -1, -1, -1], _				; sections
	[$SCE_STYLE_SYSSECTIONS, 	0x0000FF, -1,  0,  0, -1, -1, -1], _				; system sections
	[$SCE_STYLE_CONST,			0x0080FF, -1,  1,  1, -1, -1, -1], _				; special constants
	[$SCE_STYLE_ADD1, 			0x0000DD, -1,  0,  0, -1, -1, -1], _				; additional 1
	[$SCE_STYLE_ADD2, 			0xF00FA0, -1,  0,  1, -1, -1, -1], _				; additional 2
	[$SCE_STYLE_NUMS, 			0xA900AC, -1,  1,  1, -1, -1, -1], _				; numbers
	[$STYLE_BRACELIGHT, 		0x00FF00, 0x8F8F8F, -1, -1, -1, -1, -1], _ 			; matching brace
	[$STYLE_BRACEBAD, 			0xFFFFFF, 0x0000FF, -1, -1, -1, -1, -1] _ 			; not matching
	]



