;
; Many, many thanks to prog@andy and his work!
; He did a great job in developing some additional Scintilla funcs
; I took some of them out of his "SCI_Au3Extension.au3" and
; pasted them here to bring everything together I needed for my editor
;
; Holger Pandel, 2013

#include-once
#include <Math.au3>
#include "_SciLexer.au3"
#include "scintilla.h.au3"

Global Const $SCI_MARKERSETBACKSELECTED=2292
Global Const $SCI_MARKERENABLEHIGHLIGHT=2293
Global Const $SCI_SETEMPTYSELECTION=2556
Global Const $SCI_CLEARSELECTIONS=2571

; Prog@ndy
Global Const $SCI_GETWORDCHARS=2646

Global Const $tagCharacterRange = "long cpMin; long cpMax"

Global Const $tagSCNotification = "hwnd hWndFrom;int IDFrom;int Code;" & _
		"int position;" & _ ;  // SCN_STYLENEEDED, SCN_DOUBLECLICK, SCN_MODIFIED, SCN_DWELLSTART, SCN_DWELLEND, SCN_CALLTIPCLICK, SCN_HOTSPOTCLICK, SCN_HOTSPOTDOUBLECLICK
		"int ch;" & _             ;// SCN_CHARADDED, SCN_KEY
		"int modifiers;" & _      ;// SCN_KEY, SCN_DOUBLECLICK, SCN_HOTSPOTCLICK, SCN_HOTSPOTDOUBLECLICK
		"int modificationType;" & _ ;// SCN_MODIFIED
		"ptr text;" & _  ;const char *text ;// SCN_MODIFIED, SCN_USERLISTSELECTION, SCN_AUTOCSELECTION
		"int length;" & _         ;// SCN_MODIFIED
		"int linesAdded;" & _     ;// SCN_MODIFIED
		"int message;" & _        ;// SCN_MACRORECORD
		"dword wParam;" & _      ;// SCN_MACRORECORD
		"dword lParam;" & _      ;// SCN_MACRORECORD
		"int line;" & _           ;// SCN_MODIFIED, SCN_DOUBLECLICK
		"int foldLevelNow;" & _   ;// SCN_MODIFIED
		"int foldLevelPrev;" & _  ;// SCN_MODIFIED
		"int margin;" & _         ;// SCN_MARGINCLICK
		"int listType;" & _       ;// SCN_USERLISTSELECTION, SCN_AUTOCSELECTION
		"int x;" & _              ;// SCN_DWELLSTART, SCN_DWELLEND
		"int y;" & _ 			;// SCN_DWELLSTART, SCN_DWELLEND
		"int token;" & _		;// SCN_MODIFIED with SC_MOD_CONTAINER
		"int annotationLinesAdded;" & _	;// SCN_MODIFIED with SC_MOD_CHANGEANNOTATION
		"int updated;"	;// SCN_UPDATEUI
; ==> Prog@ndy

; ------------------------------------------------------------------------------------------------------------------------
; ----------------- FUNCS BY ME ------------------------------------------------------------------------------------------
; ------------------------------------------------------------------------------------------------------------------------

#region byMe
;HolgerPandel
Func Sci_AppendText($Sci, $Text)
	SendMessageString($sci, $SCI_APPENDTEXT, StringLen($text), $text)
EndFunc

;HolgerPandel
Func Sci_GetEndStyled($Sci)
	SendMessageString($sci, $SCI_GETENDSTYLED, 0, 0)
EndFunc

; HolgerPandel
Func Sci_Cancel($Sci)
	SendMessage($sci, $SCI_CANCEL,0,0)
EndFunc

;HolgerPandel
Func Sci_GotoLine($Sci, $Line)
	SendMessage($sci,$SCI_ENSUREVISIBLEENFORCEPOLICY, $line,0);
	SendMessage($sci,$SCI_GOTOLINE,$line,0)
	If @error Then
		Return 0
	Else
		Return 1
	EndIf
EndFunc

;HolgerPandel
Func Sci_EnsureRangeVisible($Sci, $posStart, $posEnd, $enforcePolicy=False)
	Local $lineStart = SendMessage($sci,$SCI_LINEFROMPOSITION,  _Min($posStart, $posEnd),0);
	Local $lineEnd = SendMessage($sci,$SCI_LINEFROMPOSITION, _Max($posStart, $posEnd),0);
	for $line = $lineStart To $lineEnd
		If ($enforcePolicy) Then
			SendMessage($sci,$SCI_ENSUREVISIBLEENFORCEPOLICY,$line,0)
		Else
			SendMessage($sci,$SCI_ENSUREVISIBLE,$line,0)

		EndIf
	Next
EndFunc

;HolgerPandel
Func Sci_GetSelectionLen($sci)
	Local $startPos = SendMessage($sci,$SCI_GETSELECTIONSTART,0,0)
	Local $endPos = SendMessage($sci,$SCI_GETSELECTIONEND,0,0)
	Local $len = $endPos-$startPos
	Return $len
EndFunc

;HolgerPandel
Func Sci_GetSelectionText($Sci)
	Local $seltext = ""
	Local $len = Sci_GetSelectionLen($Sci)
	If $len>0 Then
		Local $text = DllStructCreate("char["&$len+1&"]")
		DllCall($user32, "int", "SendMessageA", "hwnd", $sci, "int", $SCI_GETSELTEXT, "int", 0, "ptr", DllStructGetPtr($text))
		$seltext = DllStructGetData($text,1)
		$text = 0
	EndIf
	Return $seltext
EndFunc

;HolgerPandel
Func Sci_SetSearchFlags($Sci, $Flags)
	SendMessage($sci,$SCI_SETSEARCHFLAGS, $Flags,0)
EndFunc

;HolgerPandel
Func Sci_GetTargetStart($Sci)
	return SendMessage($sci,$SCI_GETTARGETSTART,0,0);
EndFunc

;HolgerPandel
Func Sci_GetTargetEnd($Sci)
	return SendMessage($sci,$SCI_GETTARGETEND,0,0);
EndFunc

;HolgerPandel
Func Sci_Clear($Sci)
	SendMessage($Sci, $SCI_CLEAR, 0, 0)
EndFunc

;HolgerPandel
Func Sci_SetUndoCollection($Sci, $mode = 1)
	SendMessage($sci, $SCI_SETUNDOCOLLECTION, $mode,0)
EndFunc

;HolgerPandel
Func Sci_GetFoldLevel($Sci, $line) ; returns an array with level (0) and flag state (1)
	local $ret[2]
	local $l = SendMessage($Sci, $SCI_GETFOLDLEVEL, $line, 0)
	$ret[0] = BitAnd($l, $SC_FOLDLEVELNUMBERMASK) ; return level
	$ret[1] = BitAnd($l, $SC_FOLDLEVELHEADERFLAG) ; return flag state
	Return $ret
EndFunc

;HolgerPandel
Func Sci_SetFoldLevel($Sci, $line, $level)
	Return SendMessage($Sci, $SCI_SETFOLDLEVEL, $line, $level) ; OR in flag to set foldpoint
EndFunc

;HolgerPandel
Func Sci_GetFoldParent ($Sci, $startline)
	Return SendMessage($Sci, $SCI_GETFOLDPARENT, $startline, 0)
EndFunc

;HolgerPandel
Func Sci_GetLastChild ($Sci, $startline, $level = -1) ; level = -1 sets end search level = startline level
	Return SendMessage($Sci, $SCI_GETLASTCHILD, $startline, $level)
EndFunc

;HolgerPandel
Func Sci_ClearCmdKey($sci,$keycode,$modifier=0)
	Return SendMessage($sci,$SCI_CLEARCMDKEY, BitShift($modifier,-16)+$keycode, 0);
EndFunc

;HolgerPandel
Func Sci_GetWordChars($Sci)
	Local $seltext = ""
	Local $len = SendMessageString($Sci, $SCI_GETWORDCHARS, 0, 0)
	If $len>0 Then
		Local $text = DllStructCreate("char["&$len+1&"]")
		DllCall($user32, "int", "SendMessageA", "hwnd", $sci, "int", $SCI_GETWORDCHARS, "int", 0, "ptr", DllStructGetPtr($text))
		$seltext = DllStructGetData($text,1)
		$text = 0
	EndIf
	Return $seltext
EndFunc

;HolgerPandel
Func Sci_SetWordChars($Sci, $charset)
	SendMessageString($Sci, $SCI_SETWORDCHARS, 0, $charset)
EndFunc

; HolgerPandel
; Routine to find first none space on the current line and return its Style
; needed for comment lines not starting on pos 1
Func Sci_GetStyleFirstWord($Sci, $line)
	Local $nsPos = Sci_GetLineStartPos($Sci, $line);
	Local $nePos = Sci_GetLineStartPos($Sci, $line + 1) - 1;
	While (_isSpaceChar(Sci_GetChar($Sci, $nsPos)) And $nsPos < $nePos)
		$nsPos += 1; // skip to next char
	WEnd
	Return Sci_GetStyleAt($Sci, $nsPos);
EndFunc   ;==>Sci_GetStyleFirstWord

; HolgerPandel
; finds first none space on the current line and return its Beginning position
Func Sci_GetPosFirstWord($Sci, $line)
	Local $nsPos = Sci_GetLineStartPos($Sci, $line);
	Local $nePos = Sci_GetLineStartPos($Sci, $line + 1) - 1;
	While (_isspacechar(Sci_GetChar($Sci, $nsPos)) And $nsPos < $nePos)
		$nsPos += 1; // skip to next char
	WEnd
	Return $nsPos
EndFunc   ;==>Sci_GetPosFirstWord

; HolgerPandel
Func _isSpaceChar($ch)
	If $ch = ' ' Or (Asc($ch) >= 9 And Asc($ch) <= 13) Then
		Return True
	Else
		Return False
	EndIf
EndFunc   ;==>_isSpaceChar
#endregion

; Holger Pandel
Func Sci_FoldAll($Sci)
	For $count = 0 To Sci_GetLineCount($Sci) - 1
		If BitAND(SendMessage($Sci, $SCI_GETFOLDLEVEL, $count, 0), $SC_FOLDLEVELHEADERFLAG) Then
			SendMessage($Sci, $SCI_TOGGLEFOLD, $count, 1)
		EndIf
	Next
EndFunc   ;==>Sci_FoldAll

; slightly modified version, Holger Pandel
Func Sci_GetTextUTF8WithoutNull($Sci)
	Local $ret, $sText
	Local $iLen = SendMessage($Sci, $SCI_GETTEXT, 0, 0)
	If @error Then
		Return 0
	EndIf
	Local $sBuf = DllStructCreate("byte[" & $iLen & "]")
	If @error Then
		Return 0
	EndIf
	$ret = DllCall($user32, "long", "SendMessageA", "long", $Sci, "int", $SCI_GETTEXT, "int", $iLen, "ptr", DllStructGetPtr($sBuf))
	If @error Then
		Return 0
	EndIf
	$sText = BinaryToString(DllStructGetData($sBuf, 1), 4) ; treat binary data as UTF-8
	$sBuf = 0
	If @error Then
		Return 0
	Else
		While Asc(StringRight($sText,1)) = 0
			$sText = StringTrimRight($sText,1)
		Wend
		Return $sText
	EndIf
EndFunc 


; ------------------------------------------------------------------------------------------------------------------------
; ----------------- FUNCS BY prog@andy -----------------------------------------------------------------------------------
; ------------------------------------------------------------------------------------------------------------------------

#region byProg@ndy
; Prog@ndy
Func Sci_GetWordFromPos($Sci, $CurrentPos, $onlyWordCharacters = 1)
	Local $start = SendMessage($Sci, $SCI_WORDSTARTPOSITION, $CurrentPos, $onlyWordCharacters)
	Local $end = SendMessage($Sci, $SCI_WORDENDPOSITION, $CurrentPos, $onlyWordCharacters)
	Return SCI_GETTEXTRANGE($Sci, $start, $end)
EndFunc

; Prog@ndy
Func Sci_GetTextRange($Sci, $start, $end)
	If $start > $end Then Return SetError(1, 0, "")
	Local $textRange = DllStructCreate($tagCharacterRange & "; ptr TextPtr; char Text[" & $end - $start + 1 & "]")
	DllStructSetData($textRange, 1, $start)
	DllStructSetData($textRange, 2, $end)
	DllStructSetData($textRange, 3, DllStructGetPtr($textRange, 4))
	SendMessage($Sci, $SCI_GETTEXTRANGE, 0, DllStructGetPtr($textRange))
	Return DllStructGetData($textRange, "Text")
EndFunc

; Prog@ndy
Func Sci_GetWordPositions($Sci, $CurrentPos, $onlyWordCharacters = 1)
	Local $Return[2] = [-1, -1]
	$Return[0] = SendMessage($Sci, $SCI_WORDSTARTPOSITION, $CurrentPos, $onlyWordCharacters)
	$Return[1] = SendMessage($Sci, $SCI_WORDENDPOSITION, $CurrentPos, $onlyWordCharacters)
	Return $Return
EndFunc
#endregion
