#include-once
#include <GUIConstantsEx.au3>
#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <ComboConstants.au3>
#include <WindowsConstants.au3>
#include <GuiButton.au3>
#include <GuiEdit.au3>
#include <GuiTab.au3>
#include <GuiComboBox.au3>
#include <GuiMenu.au3>
#include <String.au3>
#include <Array.au3>
#include <Color.au3>
#include <Misc.au3>
#include "Libs\_resize.au3"
#include "Libs\scintilla.h.au3"
#include "Libs\_SciLexer.au3"
#include "Libs\_SciLexer_Addon.au3"
#include "Libs\UDF_ArrayAlternatives.au3"
#include "Libs\IniArray_UDF.au3"
#include "Libs\_Translate.au3"
#include "Libs\FontUDF.au3"
#include "Libs\_Toolsammlung.au3"

#region 0 Definitions
; ----------- CUSTOMIZE TO YOUR LIKING --------------------------------------------
; ---------------------------------------------------------------------------------

; get additional debug output <- SLOWS DOWN EVERYTHING!!!!!
Global $__HLP_Debug = False

; default path to *.def files
Global $__lexerdef = @ScriptDir & "\LexerDef"

; default definition to load
Global $__default_lexer = 'none'

; set to the parent control id of the editor, used in _GUICtrlLex_OpenLexerDef
Global $__default_editor_parent = 'none'

; if you assign the name of a function, it will be executed right after loading a new lexer definition
; i. e. if you want to change some menu items or so in your editor
Global $__styleSelHook = ''

; ----------- THERE SHOULD BE NOTHING TO BE CHANGED BELOW THIS LINE ---------------
; ---------------------------------------------------------------------------------

; version of this UDF
Global Const $__version = "1.4"
Global $__oldGUImode

; global handle to Scintilla control, reuse in your app
Global $__hWnd_SciLexer
; global hWnd of $lstStyles
Global $__hLstStyles
; idx of selected listview item
Global $__selLstIdx = -1

; if you set this to TRUE, before you load a new document, it will prevent any styling and speeds up loading
; don't forget to set to FALSE after successful loading any files
Global $__lexRunning = False

; styler constants and dictionary for lookup in lexer def form
; for easier lookup later, we set it up once vice versa
Global $__oStyleDict = _ObjDictCreate()
; pre-defined system styles
_ObjDictAdd($__oStyleDict, $STYLE_DEFAULT, "Default") ;$STYLE_DEFAULT=32
_ObjDictAdd($__oStyleDict, "Default", $STYLE_DEFAULT) ;$STYLE_DEFAULT=32
_ObjDictAdd($__oStyleDict, $STYLE_LINENUMBER, "Linenumber") ;$STYLE_LINENUMBER=33
_ObjDictAdd($__oStyleDict, "Linenumber", $STYLE_LINENUMBER) ;$STYLE_LINENUMBER=33
_ObjDictAdd($__oStyleDict, $STYLE_BRACELIGHT, "Brace found") ;$STYLE_BRACELIGHT=34
_ObjDictAdd($__oStyleDict, "Brace found", $STYLE_BRACELIGHT) ;$STYLE_BRACELIGHT=34
_ObjDictAdd($__oStyleDict, $STYLE_BRACEBAD, "Brace not found") ;$STYLE_BRACEBAD=35
_ObjDictAdd($__oStyleDict, "Brace not found", $STYLE_BRACEBAD) ;$STYLE_BRACEBAD=35
_ObjDictAdd($__oStyleDict, $STYLE_CONTROLCHAR, "Control char") ;$STYLE_CONTROLCHAR=36
_ObjDictAdd($__oStyleDict, "Control char", $STYLE_CONTROLCHAR) ;$STYLE_CONTROLCHAR=36
_ObjDictAdd($__oStyleDict, $STYLE_INDENTGUIDE, "Indent guide") ;$STYLE_INDENTGUIDE=37
_ObjDictAdd($__oStyleDict, "Indent guide", $STYLE_INDENTGUIDE) ;$STYLE_INDENTGUIDE=37
_ObjDictAdd($__oStyleDict, $STYLE_CALLTIP, "Calltip") ;$STYLE_CALLTIP=38
_ObjDictAdd($__oStyleDict, "Calltip", $STYLE_CALLTIP) ;$STYLE_CALLTIP=38
; user defined styles
Global Const $SCE_STYLE_CONST = 11 ;
_ObjDictAdd($__oStyleDict, $SCE_STYLE_CONST, "Constant")
_ObjDictAdd($__oStyleDict, "Constant", $SCE_STYLE_CONST)
Global Const $SCE_STYLE_SYSVARS = 12 ;
_ObjDictAdd($__oStyleDict, $SCE_STYLE_SYSVARS, "System variable")
_ObjDictAdd($__oStyleDict, "System variable", $SCE_STYLE_SYSVARS)
Global Const $SCE_STYLE_KEYWORDS = 13 ;
_ObjDictAdd($__oStyleDict, $SCE_STYLE_KEYWORDS, "Keyword")
_ObjDictAdd($__oStyleDict, "Keyword", $SCE_STYLE_KEYWORDS)
Global Const $SCE_STYLE_NUMS = 14 ;
_ObjDictAdd($__oStyleDict, $SCE_STYLE_NUMS, "Numbers")
_ObjDictAdd($__oStyleDict, "Numbers", $SCE_STYLE_NUMS)
Global Const $SCE_STYLE_OPERATORS = 15 ;
_ObjDictAdd($__oStyleDict, $SCE_STYLE_OPERATORS, "Operators")
_ObjDictAdd($__oStyleDict, "Operators", $SCE_STYLE_OPERATORS)
Global Const $SCE_STYLE_COMMENTLINE = 16 ;
_ObjDictAdd($__oStyleDict, $SCE_STYLE_COMMENTLINE, "Comment line")
_ObjDictAdd($__oStyleDict, "Comment line", $SCE_STYLE_COMMENTLINE)
Global Const $SCE_STYLE_RESWORDS = 17;
_ObjDictAdd($__oStyleDict, $SCE_STYLE_RESWORDS, "Reserved")
_ObjDictAdd($__oStyleDict, "Reserved", $SCE_STYLE_RESWORDS)
Global Const $SCE_STYLE_TEXTINQUOTE = 18;
_ObjDictAdd($__oStyleDict, $SCE_STYLE_TEXTINQUOTE, "Quoted text")
_ObjDictAdd($__oStyleDict, "Quoted text", $SCE_STYLE_TEXTINQUOTE)
Global Const $SCE_STYLE_VARIABLES = 19;
_ObjDictAdd($__oStyleDict, $SCE_STYLE_VARIABLES, "Variable")
_ObjDictAdd($__oStyleDict, "Variable", $SCE_STYLE_VARIABLES)
Global Const $SCE_STYLE_FUNCTIONS = 20;
_ObjDictAdd($__oStyleDict, $SCE_STYLE_FUNCTIONS, "Function")
_ObjDictAdd($__oStyleDict, "Function", $SCE_STYLE_FUNCTIONS)
Global Const $SCE_STYLE_SECTIONS = 21;
_ObjDictAdd($__oStyleDict, $SCE_STYLE_SECTIONS, "Section")
_ObjDictAdd($__oStyleDict, "Section", $SCE_STYLE_SECTIONS)
Global Const $SCE_STYLE_COMMENTBLOCK = 22 ;
_ObjDictAdd($__oStyleDict, $SCE_STYLE_COMMENTBLOCK, "Comment block")
_ObjDictAdd($__oStyleDict, "Comment block", $SCE_STYLE_COMMENTBLOCK)
Global Const $SCE_STYLE_SYSSECTIONS = 23 ;
_ObjDictAdd($__oStyleDict, $SCE_STYLE_SYSSECTIONS, "System sections")
_ObjDictAdd($__oStyleDict, "System sections", $SCE_STYLE_SYSSECTIONS)
Global Const $SCE_STYLE_ADD1 = 24 ;
_ObjDictAdd($__oStyleDict, $SCE_STYLE_ADD1, "Additional 1")
_ObjDictAdd($__oStyleDict, "Additional 1", $SCE_STYLE_ADD1)
Global Const $SCE_STYLE_ADD2 = 25 ;
_ObjDictAdd($__oStyleDict, $SCE_STYLE_ADD2, "Additional 2")
_ObjDictAdd($__oStyleDict, "Additional 2", $SCE_STYLE_ADD2)


; react an which braces for highlighting
Local $__arBracematch[8] = ['(', ')', '[', ']', '{', '}', '<', '>']
_ArraySort($__arBracematch)

Local $__oldbracepos[2] = [-1, -1] ; position of the last brace highlighting
Local $__incomment = False ; is set to true while styling a comment block

; some perhaps useful globals set via SCN_UPDATEUI, use it for Statusbars, etc.
Global $__currentLine = 0
Global $__currentColumn = 0

; ------------------------------------------------------------------------------------------------------------------------
; --------------- SETUP SciLexer - basic defaults ------------------------------------------------------------------------
; ------------------------------------------------------------------------------------------------------------------------

; standard scintilla 0-folding level
Local $__levelCurrent = $SC_FOLDLEVELBASE
Local $__levelNext = $SC_FOLDLEVELBASE

Local $__was_folded = False

; menu item defaults
Global $__stylers
Global $__stylers_menu[1][3]

; array with menu handles, see _GUICtrlLex_CreateLexerMenu
; $__arM[0]: top menu entry, $__arM[1]: lexer picklist submenu, $__arM[2]: lexer definition form menu entry
Global $__arM[3] = [0, 0, 0]
#endregion 0 Definitions

#region 1a Main functions
; create lexer definition form
Func _GUICtrlLex_CreateLexerDefForm($frmParent = $__default_editor_parent)
	_HLP_Debug("... in _GUICtrlLex_CreateLexerDefForm()")
	#include "Forms\lexdef.isf"

	_GUICtrlButton_SetImage($btnFdAdd, "shell32.dll", 208, False)
	_GUICtrlButton_SetImage($btnFdDel, "shell32.dll", 131, False)
	_GUICtrlButton_SetImage($btnFdUpd, "shell32.dll", 144, False)
	_GUICtrlButton_SetImage($btnKeyAdd, "shell32.dll", 208, False)
	_GUICtrlButton_SetImage($btnKeyDel, "shell32.dll", 131, False)
	_GUICtrlButton_SetImage($btnKeyUpd, "shell32.dll", 144, False)
	_GUICtrlButton_SetImage($btnWordSearch, "shell32.dll", 22, False)

	
	Local $tsize, $ttf
	; pre-fill some fields
	$ttf = _FontGetList()
	$ttf = "-1|" & _ArrayToString($ttf)
	GUICtrlSetData($cmbStFontname, $ttf)
	$tsize = "-1|"
	For $i = 5 To 24
		$tsize &= $i & "|"
	Next
	GUICtrlSetData($cmbStFontsize, StringTrimRight($tsize, 1))
	
	GUISetOnEvent($GUI_EVENT_CLOSE, "_GUICtrlLex_CloseLexerDefForm", $frmLexDef)
	
	GUICtrlSetOnEvent($btnLexDefClose, "_GUICtrlLex_CloseLexerDefForm")
	GUICtrlSetOnEvent($btnLexDefSave, "_GUICtrlLex_SaveLexerDef")
	GUICtrlSetOnEvent($btnLexDefNew, "_GUICtrlLex_CreateLexerDef")
	GUICtrlSetOnEvent($btnLexDefReset, "_GUICtrlLex_ResetLexerDef")
	GUICtrlSetOnEvent($btnLexDefDel, "_GUICtrlLex_DeleteLexerDef")
	GUICtrlSetOnEvent($btnStReset, "_HLP_btnStReset")
	GUICtrlSetOnEvent($btnStText, "_HLP_ChooseFGColor")
	GUICtrlSetOnEvent($btnStBG, "_HLP_ChooseBGColor")
	GUICtrlSetOnEvent($btnFdAdd, "_HLP_btnFdAdd")
	GUICtrlSetOnEvent($btnFdDel, "_HLP_btnFdDel")
	GUICtrlSetOnEvent($btnFdUpd, "_HLP_btnFdUpd")
	GUICtrlSetOnEvent($btnKeyAdd, "_HLP_btnKeyAdd")
	GUICtrlSetOnEvent($btnKeyDel, "_HLP_btnKeyDel")
	GUICtrlSetOnEvent($btnKeyUpd, "_HLP_btnKeyUpd")
	GUICtrlSetOnEvent($btnWordSearch, "_HLP_search")
	
	; needed for special colouring routine in WM_NOTIFY
	$__hLstStyles = GUICtrlGetHandle($lstStyles)
EndFunc   ;==>_GUICtrlLex_CreateLexerDefForm

; create lexer menu with all necessary elements
; $menutype: main or sub
Func _GUICtrlLex_CreateLexerDefMenu($menutype = 'main', $submen = "")
	If $menutype = 'main' Then
		Local $__mLexer = GUICtrlCreateMenu(__("&Lexer"))
	Else
		Local $__mLexer = GUICtrlCreateMenuItem(__("&Lexer"), $submen)
	EndIf
	Local $__mChooseLex = GUICtrlCreateMenu(__("Choose Lexer"), $__mLexer)
	Local $__mLexerDef = GUICtrlCreateMenuItem(__("Lexer definition"), $__mLexer)

	GUICtrlSetOnEvent($__mLexerDef, "_GUICtrlLex_OpenLexerDef")
	
	_HLP_CreateLexerPickList($__mChooseLex)

	$__arM[0] = $__mLexer
	$__arM[1] = $__mChooseLex
	$__arM[2] = $__mLexerDef
	Return $__arM
EndFunc   ;==>_GUICtrlLex_CreateLexerDefMenu

; load chosen Styler
Func _GUICtrlLex_selectLexer()
	; find selected styler, load and check
	For $i = 0 To UBound($__stylers_menu) - 1
		If $__stylers_menu[$i][0] = @GUI_CtrlId Then
			ExitLoop
		EndIf
	Next
	_GUICtrlLex_ReadLEXFile($__stylers_menu[$i][1])
	_GUICtrlLex_SetupStylingAndFolding()
	Call($__styleSelHook)
	SendMessage($__hWnd_SciLexer, $SCI_COLOURISE, 0, -1)
EndFunc   ;==>_GUICtrlLex_selectLexer

; read every style def parameter from file
Func _GUICtrlLex_ReadLEXFile($lang = '*@reset@*', $defhigh = -1, $deffold = -1, $defcomment = -1, $defcompact = -1)
	If Not FileExists($__lexerdef & "\" & $lang & ".def") Then $lang = '<reset>'
	$__default_lexer = $lang
	Global $__filetypes = IniRead($__lexerdef & "\" & $lang & ".def", "Basic", "files", "All (*.*)")
	Global $__name = IniRead($__lexerdef & "\" & $lang & ".def", "Basic", "name", "<enter description>")
	Global $__keywords = _HLP_ReadKeywordsFromINI($lang, "Keywords", "keywords")
	Global $__fuwords = _HLP_ReadKeywordsFromINI($lang, "Keywords", "fuwords")
	Global $__reswords = _HLP_ReadKeywordsFromINI($lang, "Keywords", "reswords")
	Global $__consts = _HLP_ReadKeywordsFromINI($lang, "Keywords", "constwords")
	Global $__add1 = _HLP_ReadKeywordsFromINI($lang, "Keywords", "addone")
	Global $__add2 = _HLP_ReadKeywordsFromINI($lang, "Keywords", "addtwo")
	Global $__syssections = _HLP_ReadKeywordsFromINI($lang, "Keywords", "syssections")
	Global $__blockcomments = IniRead($__lexerdef & "\" & $lang & ".def", "Keywords", "blockcomments", "")
	Global $__operator = IniRead($__lexerdef & "\" & $lang & ".def", "Characters", "operator", "")
	Global $__braces = IniRead($__lexerdef & "\" & $lang & ".def", "Characters", "braces", "< > ( ) [ ] { }")
	Global $__charsForVars = IniRead($__lexerdef & "\" & $lang & ".def", "Characters", "varchar", "abcdefghijklmnopqrstuvwXYZABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789")
	Global $__specLeadChars = IniRead($__lexerdef & "\" & $lang & ".def", "Characters", "lead", "")
	Global $__quot = IniRead($__lexerdef & "\" & $lang & ".def", "Characters", "quot", Chr(34))
	Global $__apostrophe = IniRead($__lexerdef & "\" & $lang & ".def", "Characters", "apo", Chr(39))
	Global $__charComLine = IniRead($__lexerdef & "\" & $lang & ".def", "Characters", "commentline", "")
	Global $__sectOp = IniRead($__lexerdef & "\" & $lang & ".def", "Characters", "sect_open", "")
	Global $__sectCl = IniRead($__lexerdef & "\" & $lang & ".def", "Characters", "sect_close", "")
	Global $__varMark = IniRead($__lexerdef & "\" & $lang & ".def", "Characters", "var_mark", "")
	Global $__varEndMark = IniRead($__lexerdef & "\" & $lang & ".def", "Characters", "var_end_mark", "")
	Global $__sysVarMark = IniRead($__lexerdef & "\" & $lang & ".def", "Characters", "sysvar_mark", "")
	Global $__sysVarEndMark = IniRead($__lexerdef & "\" & $lang & ".def", "Characters", "sysvar_end_mark", "")
	Global $__constsMark = IniRead($__lexerdef & "\" & $lang & ".def", "Characters", "const_mark", "")
	Global $__constsEndMark = IniRead($__lexerdef & "\" & $lang & ".def", "Characters", "const_end_mark", "")
	Global $__hasSects = False
	If IniRead($__lexerdef & "\" & $lang & ".def", "Control", "has_sects", "") = 'True' Then $__hasSects = True
	Global $__varNested = False
	If IniRead($__lexerdef & "\" & $lang & ".def", "Control", "var_nested", False) = 'True' Then $__varNested = True
	Global $__sysVarNested = False
	If IniRead($__lexerdef & "\" & $lang & ".def", "Control", "sysvar_nested", False) = 'True' Then $__sysVarNested = True
	Global $__constsNested = False
	If IniRead($__lexerdef & "\" & $lang & ".def", "Control", "const_nested", False) = 'True' Then $__constsNested = True
	Global $__foldingElements = IniRead($__lexerdef & "\" & $lang & ".def", "Folding", "fold_lang_elem", "")
	Global $__arFoldingBasic = ""
	$__arFoldingBasic = _IniReadArray($__lexerdef & "\" & $lang & ".def", "Folding", "fold_elements", False)
	If $__arFoldingBasic = 0 Then $__arFoldingBasic = _String2Array2D("empty,,0,0,True", '|', ',', False)

	Global $__arFoldingLV = $__arFoldingBasic ; $__arFoldingLV is only for temporary edits in the listview
	Global $__incComLine = False
	If IniRead($__lexerdef & "\" & $lang & ".def", "Folding", "inc_comm", False) = 'True' Then $__incComLine = True
	Global $__incSects = False
	If IniRead($__lexerdef & "\" & $lang & ".def", "Folding", "inc_sects", False) = 'True' Then $__incSects = True
	Global $__defFold = False
	If IniRead($__lexerdef & "\" & $lang & ".def", "Folding", "def_fold", False) = 'True' Then $__defFold = True
	Global $__defFoldComment = False
	If IniRead($__lexerdef & "\" & $lang & ".def", "Folding", "def_fold_com", False) = 'True' Then $__defFoldComment = True
	Global $__defFoldCompact = False
	If IniRead($__lexerdef & "\" & $lang & ".def", "Folding", "def_fold_cp", False) = 'True' Then $__defFoldCompact = True
	Global $__defHighlight = False
	If IniRead($__lexerdef & "\" & $lang & ".def", "Styling", "def_high", False) = 'True' Then $__defHighlight = True
	Global $__arStyles = ""
	$__arStyles = _IniReadArray($__lexerdef & "\" & $lang & ".def", "Styling", "styles", False)
	If $__arStyles = 0 Then $__arStyles = _String2Array2D("32,0,16777215,0,0,0,Courier New,10|13,8978463,16777215,1,0,-1,-1,-1|12,12255419,16777215,1,1,-1,-1,-1|15,255,16777215,-1,-1,-1,-1,-1|16,3827405,16777215,-1,-1,-1,-1,-1|22,39270,16777215,-1,-1,-1,-1,-1|18,14954726,16777215,1,-1,-1,-1,-1|17,16744448,16777215,0,0,-1,-1,-1|19,36864,16777215,1,0,-1,-1,-1|20,11689782,16777215,0,0,-1,-1,-1|21,0,16777215,1,1,-1,-1,-1|23,255,16777215,0,0,-1,-1,-1|11,33023,16777215,1,1,-1,-1,-1|24,221,16777215,0,0,-1,-1,-1|25,15732640,16777215,0,1,-1,-1,-1|14,11075756,16777215,1,1,-1,-1,-1|34,65280,9408399,-1,-1,-1,-1,-1|35,16777215,255,-1,-1,-1,-1,-1", '|', ',', False)
	; overwrite default_fold and default_highlight with function parameters
	If $deffold = 1 Then $__defFold = True
	If $deffold = 0 Then $__defFold = False
	If $defhigh = 1 Then $__defHighlight = True
	If $defhigh = 0 Then $__defHighlight = False
	If $defcomment = 1 Then $__defFoldComment = True
	If $defcomment = 0 Then $__defFoldComment = False
	If $defcompact = 1 Then $__defFoldCompact = True
	If $defcompact = 0 Then $__defFoldCompact = False

	; update menu
	_HLP_MarkMenuItem()
EndFunc   ;==>_GUICtrlLex_ReadLEXFile

; write every style def parameter to file
Func _GUICtrlLex_WriteLEXFile($lang)
	DirCreate($__lexerdef) ; if it's the first
	If FileExists($__lexerdef & "\" & $lang & ".def") Then FileDelete($__lexerdef & "\" & $lang & ".def") ; clean up old crap

	Local $rc = IniWrite($__lexerdef & "\" & $lang & ".def", "Basic", "version", $__version)
	If $rc = 0 Then
		MsgBox(262208, __('Saving'), __('Definition not saved. File read-only?'), 0)
		Return
	EndIf
	
	IniWrite($__lexerdef & "\" & $lang & ".def", "Basic", "files", $__filetypes)
	IniWrite($__lexerdef & "\" & $lang & ".def", "Basic", "name", $__name)
	_HLP_WriteKeywordsToINI($lang, "Keywords", $__keywords, "keywords")
	_HLP_WriteKeywordsToINI($lang, "Keywords", $__fuwords, "fuwords")
	_HLP_WriteKeywordsToINI($lang, "Keywords", $__reswords, "reswords")
	_HLP_WriteKeywordsToINI($lang, "Keywords", $__consts, "constwords")
	_HLP_WriteKeywordsToINI($lang, "Keywords", $__add1, "addone")
	_HLP_WriteKeywordsToINI($lang, "Keywords", $__add2, "addtwo")
	_HLP_WriteKeywordsToINI($lang, "Keywords", $__syssections, "syssections")
	IniWrite($__lexerdef & "\" & $lang & ".def", "Keywords", "blockcomments", $__blockcomments)
	IniWrite($__lexerdef & "\" & $lang & ".def", "Characters", "operator", $__operator)
	IniWrite($__lexerdef & "\" & $lang & ".def", "Characters", "braces", $__braces)
	IniWrite($__lexerdef & "\" & $lang & ".def", "Characters", "varchar", $__charsForVars)
	IniWrite($__lexerdef & "\" & $lang & ".def", "Characters", "lead", $__specLeadChars)
	IniWrite($__lexerdef & "\" & $lang & ".def", "Characters", "quot", $__quot)
	IniWrite($__lexerdef & "\" & $lang & ".def", "Characters", "apo", $__apostrophe)
	IniWrite($__lexerdef & "\" & $lang & ".def", "Characters", "commentline", $__charComLine)
	IniWrite($__lexerdef & "\" & $lang & ".def", "Characters", "sect_open", $__sectOp)
	IniWrite($__lexerdef & "\" & $lang & ".def", "Characters", "sect_close", $__sectCl)
	IniWrite($__lexerdef & "\" & $lang & ".def", "Characters", "var_mark", $__varMark)
	IniWrite($__lexerdef & "\" & $lang & ".def", "Characters", "var_end_mark", $__varEndMark)
	IniWrite($__lexerdef & "\" & $lang & ".def", "Characters", "sysvar_mark", $__sysVarMark)
	IniWrite($__lexerdef & "\" & $lang & ".def", "Characters", "sysvar_end_mark", $__sysVarEndMark)
	IniWrite($__lexerdef & "\" & $lang & ".def", "Characters", "const_mark", $__constsMark)
	IniWrite($__lexerdef & "\" & $lang & ".def", "Characters", "const_end_mark", $__constsEndMark)
	IniWrite($__lexerdef & "\" & $lang & ".def", "Control", "has_sects", $__hasSects)
	IniWrite($__lexerdef & "\" & $lang & ".def", "Control", "var_nested", $__varNested)
	IniWrite($__lexerdef & "\" & $lang & ".def", "Control", "sysvar_nested", $__sysVarNested)
	IniWrite($__lexerdef & "\" & $lang & ".def", "Control", "const_nested", $__constsNested)
	IniWrite($__lexerdef & "\" & $lang & ".def", "Folding", "fold_lang_elem", $__foldingElements)
	IniWrite($__lexerdef & "\" & $lang & ".def", "Folding", "inc_comm", $__incComLine)
	IniWrite($__lexerdef & "\" & $lang & ".def", "Folding", "inc_sects", $__incSects)
	IniWrite($__lexerdef & "\" & $lang & ".def", "Folding", "def_fold", $__defFold)
	IniWrite($__lexerdef & "\" & $lang & ".def", "Folding", "def_fold_com", $__defFoldComment)
	IniWrite($__lexerdef & "\" & $lang & ".def", "Folding", "def_fold_cp", $__defFoldCompact)
	_IniWriteArray($__lexerdef & "\" & $lang & ".def", "Folding", "fold_elements", $__arFoldingBasic, False)
	IniWrite($__lexerdef & "\" & $lang & ".def", "Styling", "def_high", $__defHighlight)
	_IniWriteArray($__lexerdef & "\" & $lang & ".def", "Styling", "styles", $__arStyles, False)
EndFunc   ;==>_GUICtrlLex_WriteLEXFile

; write the content of $variable under $section with $name to INI file ($lang)
Func _HLP_WriteKeywordsToINI($lang, $section, $variable, $name)
	If $variable[0] > 0 Then
		IniWrite($__lexerdef & "\" & $lang & ".def", $section, $name & "_count", $variable[0])
		For $i = 1 To $variable[0]
			IniWrite($__lexerdef & "\" & $lang & ".def", $section, $name & $i, $variable[$i])
		Next
	Else
		IniWrite($__lexerdef & "\" & $lang & ".def", $section, $name & "_count", 0)
	EndIf
EndFunc   ;==>_HLP_WriteKeywordsToINI

; get all keywords from $section and return them
Func _HLP_ReadKeywordsFromINI($lang, $section, $name)
	Local $variable[2], $count
	$count = IniRead($__lexerdef & "\" & $lang & ".def", $section, $name & "_count", 0)
	If $count > 0 Then
		ReDim $variable[$count + 1]
		$variable[0] = $count
		For $i = 1 To $count
			$variable[$i] = IniRead($__lexerdef & "\" & $lang & ".def", $section, $name & $i, "")
		Next
	Else
		$variable[0] = 0
		$variable[1] = "<no keywords defined for this category>"
	EndIf
	
	Return $variable
EndFunc   ;==>_HLP_ReadKeywordsFromINI

; main Scintilla setup function, call after creation
Func _GUICtrlLex_SetupStylingAndFolding()
	_HLP_Debug("... in _GUICtrlLex_SetupStylingAndFolding()")

	; ------------------------------------------------------------------------------------------------------------------------
	; --------------- SETUP SciLexer - MAIN WORD DICTS -----------------------------------------------------------------------
	; ------------------------------------------------------------------------------------------------------------------------

	; HAS to be an UNSORTED array because of odd/even (block tags open=even + close=false) check of elements!!!
	Global $__arBlockComments = StringSplit($__blockcomments, " ", 3)

	; keyword object hashes for faster search
	Local $aTmp
	Global $__oKeywords = 0
	Global $__oReswords = 0
	Global $__oFuwords = 0
	Global $__oConstwords = 0
	Global $__oAdditional_1 = 0
	Global $__oAdditional_2 = 0
	Global $__oSyssections = 0
	Global $__oOps = 0
	Global $__oBraces = 0
	$__oKeywords = _HLP_CreateDict($__keywords)
	$__oReswords = _HLP_CreateDict($__reswords)
	$__oFuwords = _HLP_CreateDict($__fuwords)
	$__oConstwords = _HLP_CreateDict($__consts)
	$__oAdditional_1 = _HLP_CreateDict($__add1)
	$__oAdditional_2 = _HLP_CreateDict($__add2)
	$__oSyssections = _HLP_CreateDict($__syssections)
	$__oOps = _HLP_CreateDict($__operator)
	$__oBraces = _HLP_CreateDict($__braces)

	; copy the basic array, so that we can add sections or comments dynamically
	; and sort the folding array to be able to do a binary search
	Global $__arFolding = $__arFoldingBasic
	_ArraySort($__arFolding)

	; folding / highlighting setup
	Global $__highlight = $__defHighlight
	Global $__fold = $__defFold ; turn folding on/off
	Global $__foldCompact = $__defFoldCompact ; should empty lines be compacted when folding
	Global $__foldComment = $__defFoldComment; fold (single line) comments

	; ------------------------------------------------------------------------------------------------------------------------
	; --------------- SETUP SciLexer - CONTAINER and STYLES ------------------------------------------------------------------
	; ------------------------------------------------------------------------------------------------------------------------

	; set Lexer to SLex_CONTAINER
	Sci_SetLexer($__hWnd_SciLexer, $SCLex_CONTAINER)

	; setup DEFAULT styles and reset every custom style
	Sci_StyleSet($__hWnd_SciLexer, $__arStyles[0][0], $__arStyles[0][1], $__arStyles[0][2], $__arStyles[0][3], $__arStyles[0][4], $__arStyles[0][5], $__arStyles[0][6], $__arStyles[0][7])
	Sci_StyleClearAll($__hWnd_SciLexer) ; This might look weird, but it resets all styles to de default style.

	; now setup every other style, which is needed
	For $i = 1 To UBound($__arStyles) - 1
		Sci_StyleSet($__hWnd_SciLexer, $__arStyles[$i][0], $__arStyles[$i][1], $__arStyles[$i][2], $__arStyles[$i][3], $__arStyles[$i][4], $__arStyles[$i][5], $__arStyles[$i][6], $__arStyles[$i][7])
	Next

	; ------------------------------------------------------------------------------------------------------------------------
	; --------------- SETUP SciLexer - MARGINS -------------------------------------------------------------------------------
	; ------------------------------------------------------------------------------------------------------------------------

	; setup startup margins
	$pixelWidth = SendMessageString($__hWnd_SciLexer, $SCI_TEXTWIDTH, $STYLE_LINENUMBER, "99999")
	SendMessage($__hWnd_SciLexer, $SCI_SETMARGINWIDTHN, 0, $pixelWidth);
	;Sendmessage($__hWnd_SciLexer, $SCI_SETMARGINWIDTHN, 0, 70) ; Zeilennummern
	Sendmessage($__hWnd_SciLexer, $SCI_SETMARGINWIDTHN, 1, 0) ; Zwischenabstand
	Sendmessage($__hWnd_SciLexer, $SCI_SETMARGINWIDTHN, 2, 15) ; Symbole
	Sendmessage($__hWnd_SciLexer, $SCI_SETMARGINWIDTHN, 3, 0) ; Abstand zum Textfeld

	; ------------------------------------------------------------------------------------------------------------------------
	; --------------- SETUP SciLexer - FOLDING -------------------------------------------------------------------------------
	; ------------------------------------------------------------------------------------------------------------------------

	; set folder markers
	SendMessage($__hWnd_SciLexer, $SCI_MARKERDEFINE, $SC_MARKNUM_FOLDEROPEN, $SC_MARK_BOXMINUS)
	SendMessage($__hWnd_SciLexer, $SCI_MARKERDEFINE, $SC_MARKNUM_FOLDER, $SC_MARK_BOXPLUS)
	SendMessage($__hWnd_SciLexer, $SCI_MARKERDEFINE, $SC_MARKNUM_FOLDERSUB, $SC_MARK_VLINE)
	SendMessage($__hWnd_SciLexer, $SCI_MARKERDEFINE, $SC_MARKNUM_FOLDERTAIL, $SC_MARK_LCORNER)
	SendMessage($__hWnd_SciLexer, $SCI_MARKERDEFINE, $SC_MARKNUM_FOLDEREND, $SC_MARK_BOXPLUSCONNECTED)
	SendMessage($__hWnd_SciLexer, $SCI_MARKERDEFINE, $SC_MARKNUM_FOLDEROPENMID, $SC_MARK_BOXMINUSCONNECTED)
	SendMessage($__hWnd_SciLexer, $SCI_MARKERDEFINE, $SC_MARKNUM_FOLDERMIDTAIL, $SC_MARK_TCORNER)
	SendMessage($__hWnd_SciLexer, $SCI_SETFOLDFLAGS, 16, 0)
	; set fore/background of markers
	SendMessage($__hWnd_SciLexer, $SCI_MARKERSETFORE, $SC_MARKNUM_FOLDER, 0xFFFFFF)
	SendMessage($__hWnd_SciLexer, $SCI_MARKERSETBACK, $SC_MARKNUM_FOLDERSUB, 0x808080)
	SendMessage($__hWnd_SciLexer, $SCI_MARKERSETBACK, $SC_MARKNUM_FOLDEREND, 0x808080)
	SendMessage($__hWnd_SciLexer, $SCI_MARKERSETFORE, $SC_MARKNUM_FOLDEREND, 0xFFFFFF)
	SendMessage($__hWnd_SciLexer, $SCI_MARKERSETBACK, $SC_MARKNUM_FOLDERTAIL, 0x808080)
	SendMessage($__hWnd_SciLexer, $SCI_MARKERSETBACK, $SC_MARKNUM_FOLDERMIDTAIL, 0x808080)
	SendMessage($__hWnd_SciLexer, $SCI_MARKERSETBACK, $SC_MARKNUM_FOLDER, 0x808080)
	SendMessage($__hWnd_SciLexer, $SCI_MARKERSETFORE, $SC_MARKNUM_FOLDEROPEN, 0xFFFFFF)
	SendMessage($__hWnd_SciLexer, $SCI_MARKERSETBACK, $SC_MARKNUM_FOLDEROPEN, 0x808080)
	SendMessage($__hWnd_SciLexer, $SCI_MARKERSETFORE, $SC_MARKNUM_FOLDEROPENMID, 0xFFFFFF)
	SendMessage($__hWnd_SciLexer, $SCI_MARKERSETBACK, $SC_MARKNUM_FOLDEROPENMID, 0x808080)
	SendMessage($__hWnd_SciLexer, $SCI_SETMARGINSENSITIVEN, $MARGIN_SCRIPT_FOLD, 1)
	SendMessage($__hWnd_SciLexer, $SCI_MARKERENABLEHIGHLIGHT, 1, 0)

	; ------------------------------------------------------------------------------------------------------------------------
	; --------------- SETUP SciLexer - CHARACTER SET -------------------------------------------------------------------------
	; ------------------------------------------------------------------------------------------------------------------------
	
	; default to UTF-8 codepage
	SendMessage($__hWnd_SciLexer, $SCI_SETCODEPAGE, $SC_CP_UTF8, 0)
	
	Local $charset = Sci_GetWordChars($__hWnd_SciLexer)
	_HLP_Debug("-> standard charset: " & $charset)
	Sci_SetWordChars($__hWnd_SciLexer, $charset & $__specLeadChars)
	$charset = Sci_GetWordChars($__hWnd_SciLexer)
	_HLP_Debug("-> extended charset: " & $charset)

	; ------------------------------------------------------------------------------------------------------------------------
	; --------------- SETUP SciLexer - BLOCK FOLDING -------------------------------------------------------------------------
	; ------------------------------------------------------------------------------------------------------------------------

	_GUICtrlLex_SetupFoldingArray()
EndFunc   ;==>_GUICtrlLex_SetupStylingAndFolding

; rebuild folding array to include/exclude comment blocks
Func _GUICtrlLex_SetupFoldingArray()
	_HLP_Debug("... in _GUICtrlLex_SetupFoldingArray()")

	; we need REAL boolean values, not strings... in [4]
	For $i = 0 To UBound($__arFoldingBasic) - 1
		If $__arFoldingBasic[$i][4] = 'True' Then
			$__arFoldingBasic[$i][4] = True
		Else
			$__arFoldingBasic[$i][4] = False
		EndIf
	Next
	
	; reset array
	$__arFolding = ''
	$__arFolding = $__arFoldingBasic

	; add single line and sections if needed
	If $__incComLine Then
		$__foldingElements = UBound($__arFolding) + 1
		ReDim $__arFolding[$__foldingElements][5]
		$__arFolding[$__foldingElements - 1][0] = $__charComLine
		$__arFolding[$__foldingElements - 1][1] = ""
		$__arFolding[$__foldingElements - 1][2] = 0
		$__arFolding[$__foldingElements - 1][3] = 1
		$__arFolding[$__foldingElements - 1][4] = False
	EndIf
	If $__incSects Then
		$__foldingElements = UBound($__arFolding) + 1
		ReDim $__arFolding[$__foldingElements][5]
		$__arFolding[$__foldingElements - 1][0] = $__sectOp
		$__arFolding[$__foldingElements - 1][1] = ""
		$__arFolding[$__foldingElements - 1][2] = 0
		$__arFolding[$__foldingElements - 1][3] = 1
		$__arFolding[$__foldingElements - 1][4] = False
	EndIf

	; add every block comment element to folding array
	; like: [$comment_block_begin, "", 0, 1, True],[$comment_block_end, "", -1, -1, False]
	If $__foldComment Then
		If IsArray($__arBlockComments) Then
			If Mod(UBound($__arBlockComments), 2) = 0 Then ; make sure that we have an even number of elements in the array
				Local $begin = True
				For $e In $__arBlockComments
					Local $max = UBound($__arFolding)
					ReDim $__arFolding[$max + 1][5]
					$__arFolding[$max][0] = $e
					$__arFolding[$max][1] = ""
					$__arFolding[$max][4] = True
					If $begin Then
						$__arFolding[$max][2] = 0
						$__arFolding[$max][3] = 1
						$begin = False
					Else
						$__arFolding[$max][2] = 0
						$__arFolding[$max][3] = -1
						$begin = True
					EndIf
				Next
			EndIf
		EndIf
	EndIf
	_ArraySort($__arFolding)
EndFunc   ;==>_GUICtrlLex_SetupFoldingArray

; set initial field values
Func _GUICtrlLex_SetFields()
	_HLP_Debug("... in _GUICtrlLex_SetFields()")
	_GUICtrlListView_DeleteAllItems(GUICtrlGetHandle($lstKeywords))
	_GUICtrlListView_DeleteAllItems(GUICtrlGetHandle($lstFolds))
	_GUICtrlListView_DeleteAllItems(GUICtrlGetHandle($lstStyles))
	_HLP_CheckSet($chkStyling, $__defHighlight)
	_HLP_CheckSet($chkVarNested, $__varNested)
	_HLP_CheckSet($chkSysVarNested, $__sysVarNested)
	_HLP_CheckSet($chkConstNested, $__constsNested)
	_HLP_CheckSet($chkFolding, $__defFold)
	_HLP_CheckSet($chkFoldComment, $__defFoldComment)
	_HLP_CheckSet($chkFoldCompact, $__defFoldCompact)
	_HLP_CheckSet($chkIncComLine, $__incComLine)
	_HLP_CheckSet($chkIncSections, $__incSects)
	If $__hasSects Then
		GUICtrlSetState($rdSectYes, $gui_checked)
		GUICtrlSetState($inputSectOpen, $gui_enable)
		GUICtrlSetState($inputSectClose, $gui_enable)
		GUICtrlSetState($chkIncSections, $gui_enable)
	Else
		GUICtrlSetState($rdSectNo, $gui_checked)
		GUICtrlSetState($inputSectOpen, $gui_disable)
		GUICtrlSetState($inputSectClose, $gui_disable)
		GUICtrlSetState($chkIncSections, $gui_disable)
	EndIf
	GUICtrlSetData($inputLexerFileFilter, $__filetypes)
	GUICtrlSetData($inputLexerDesc, $__name)
	GUICtrlSetData($inputOperator, $__operator)
	GUICtrlSetData($inputBraces, $__braces)
	GUICtrlSetData($inputSingleLineComment, $__charComLine)
	GUICtrlSetData($inputLeadingChar, $__specLeadChars)
	GUICtrlSetData($inputSectOpen, $__sectOp)
	GUICtrlSetData($inputSectClose, $__sectCl)
	GUICtrlSetData($inputQuot, $__quot)
	GUICtrlSetData($inputApo, $__apostrophe)
	GUICtrlSetData($inputCharsForVariables, $__charsForVars)
	GUICtrlSetData($inputVarMark, $__varMark)
	GUICtrlSetData($inputVarEndMark, $__varEndMark)
	GUICtrlSetData($inputSysvarMark, $__sysVarMark)
	GUICtrlSetData($inputSysvarEndMark, $__sysVarEndMark)
	GUICtrlSetData($inputConstMark, $__constsMark)
	GUICtrlSetData($inputConstEndMark, $__constsEndMark)
	GUICtrlSetData($inputBlockComments, $__blockcomments)
	; listview keywords
	_GUICtrlListView_BeginUpdate($lstKeywords)
	_HLP_WriteKeywordsToListView($lstKeywords, $__keywords, "Keyword")
	_HLP_WriteKeywordsToListView($lstKeywords, $__fuwords, "Function")
	_HLP_WriteKeywordsToListView($lstKeywords, $__reswords, "Reserved")
	_HLP_WriteKeywordsToListView($lstKeywords, $__consts, "Constant")
	_HLP_WriteKeywordsToListView($lstKeywords, $__syssections, "SysSections")
	_HLP_WriteKeywordsToListView($lstKeywords, $__add1, "Additional1")
	_HLP_WriteKeywordsToListView($lstKeywords, $__add2, "Additional2")
	_GUICtrlListView_SetColumnWidth($lstKeywords, 1, $LVSCW_AUTOSIZE_USEHEADER)
	_GUICtrlListView_EndUpdate($lstKeywords)

	; listview folding
	_HLP_updListView($lstFolds, $__arFoldingBasic)

	; listview styles + coloured backgrounds
	_HLP_SetStylesLV()

	; show available stylers in combo box
	_HLP_ListLexer()
	;GUICtrlSetData($cmbKeywordType, __("Keyword|Function|Reserved|Constant|Add1|Add2"))
EndFunc   ;==>_GUICtrlLex_SetFields

Func _GUICtrlLex_GetFields()
	_HLP_Debug("... in _GUICtrlLex_GetFields()")
	$__defHighlight = _HLP_CheckGet($chkStyling)
	$__varNested = _HLP_CheckGet($chkVarNested)
	$__sysVarNested = _HLP_CheckGet($chkSysVarNested)
	$__constsNested = _HLP_CheckGet($chkConstNested)
	$__defFold = _HLP_CheckGet($chkFolding)
	$__defFoldComment = _HLP_CheckGet($chkFoldComment)
	$__defFoldCompact = _HLP_CheckGet($chkFoldCompact)
	$__incComLine = _HLP_CheckGet($chkIncComLine)
	$__incSects = _HLP_CheckGet($chkIncSections)
	If GUICtrlRead($rdSectYes) = $gui_checked Then
		$__hasSects = True
	Else
		$__hasSects = False
	EndIf
	$__name = GUICtrlRead($inputLexerDesc)
	$__filetypes = GUICtrlRead($inputLexerFileFilter)
	$__operator = GUICtrlRead($inputOperator)
	$__braces = GUICtrlRead($inputBraces)
	$__charComLine = GUICtrlRead($inputSingleLineComment)
	$__specLeadChars = GUICtrlRead($inputLeadingChar)
	$__sectOp = GUICtrlRead($inputSectOpen)
	$__sectCl = GUICtrlRead($inputSectClose)
	$__quot = GUICtrlRead($inputQuot)
	$__apostrophe = GUICtrlRead($inputApo)
	$__charsForVars = GUICtrlRead($inputCharsForVariables)
	$__varMark = GUICtrlRead($inputVarMark)
	$__varEndMark = GUICtrlRead($inputVarEndMark)
	$__sysVarMark = GUICtrlRead($inputSysvarMark)
	$__sysVarEndMark = GUICtrlRead($inputSysvarEndMark)
	$__constsMark = GUICtrlRead($inputConstMark)
	$__constsEndMark = GUICtrlRead($inputConstEndMark)
	$__blockcomments = StringStripWS(GUICtrlRead($inputBlockComments), 7)
	; get folding listview
	For $i = 0 To _GUICtrlListView_GetItemCount($lstFolds) - 1
		If Not IsArray($__arFoldingBasic) Then
			Global $__arFoldingBasic[1][5]
		Else
			ReDim $__arFoldingBasic[$i + 1][5]
		EndIf
		Local $tmp = _GUICtrlListView_GetItemTextArray($lstFolds, $i)
		$__arFoldingBasic[$i][0] = $tmp[1]
		$__arFoldingBasic[$i][1] = $tmp[2]
		$__arFoldingBasic[$i][2] = $tmp[3]
		$__arFoldingBasic[$i][3] = $tmp[4]
		$__arFoldingBasic[$i][4] = $tmp[5]
	Next
	; get styles
	For $i = 0 To _GUICtrlListView_GetItemCount($lstStyles) - 1
		ReDim $__arStyles[$i + 1][8]
		Local $tmp = _GUICtrlListView_GetItemTextArray($lstStyles, $i)
		$__arStyles[$i][0] = $__oStyleDict.Item($tmp[1])
		$__arStyles[$i][1] = _HLP_ColorConvert($tmp[2])
		$__arStyles[$i][2] = _HLP_ColorConvert($tmp[3])
		$__arStyles[$i][3] = $tmp[4]
		$__arStyles[$i][4] = $tmp[5]
		$__arStyles[$i][5] = $tmp[6]
		$__arStyles[$i][6] = $tmp[7]
		$__arStyles[$i][7] = $tmp[8]
	Next
	; get keywords
	$__keywords = _HLP_GetKeywordsFromListView($lstKeywords, "Keyword")
	$__fuwords = _HLP_GetKeywordsFromListView($lstKeywords, "Function")
	$__reswords = _HLP_GetKeywordsFromListView($lstKeywords, "Reserved")
	$__consts = _HLP_GetKeywordsFromListView($lstKeywords, "Constant")
	$__syssections = _HLP_GetKeywordsFromListView($lstKeywords, "SysSections")
	$__add1 = _HLP_GetKeywordsFromListView($lstKeywords, "Additional1")
	$__add2 = _HLP_GetKeywordsFromListView($lstKeywords, "Additional2")
	
EndFunc   ;==>_GUICtrlLex_GetFields

; main routine to open lexer definition window
Func _GUICtrlLex_OpenLexerDef()
	_HLP_Debug("... in _GUICtrlLex_OpenLexerDef()")
	$__oldGUImode = Opt("GUIOnEventMode", 1)
	; setup field values
	_GUICtrlLex_CreateLexerDefForm($__default_editor_parent)
	WinSetTitle($frmLexDef, "", "Lexer Definition: " & $__name)
	#cs
		; Get the font of the ListView control
		; Copied from the _GUICtrlGetFont example by KaFu
		; See http://www.autoitscript.com/forum/index.php?showtopic=124526
		Local $hDC = _WinAPI_GetDC($__hLstStyles)
		Local $hFont = _SendMessage($__hLstStyles, $WM_GETFONT)
		Local $hObject = _WinAPI_SelectObject($hDC, $hFont)
		Local $lvLOGFONT = DllStructCreate($tagLOGFONT)
		Local $aRet = DllCall('gdi32.dll', 'int', 'GetObjectW', 'ptr', $hFont, 'int', DllStructGetSize($lvLOGFONT), 'ptr', DllStructGetPtr($lvLOGFONT))
		_WinAPI_SelectObject($hDC, $hObject)
		_WinAPI_ReleaseDC($__hLstStyles, $hDC)
		Global $hLVfont = _WinAPI_CreateFontIndirect( $lvLOGFONT )
		Local $iWeight = BitOR( DllStructGetData( $lvLOGFONT, "Weight" ), $FW_BOLD )
		DllStructSetData( $lvLOGFONT, "Weight", $iWeight )
		Global $hLVfontBold = _WinAPI_CreateFontIndirect( $lvLOGFONT )
	#ce

	_GUICtrlLex_SetFields()

	_GUICtrlTab_SetCurFocus($tab, 0)
	GUISetState(@SW_SHOW, $frmLexDef)

	_HLP_DisableButtons_Styles()
	_HLP_DisableButtons_Folds()
EndFunc   ;==>_GUICtrlLex_OpenLexerDef

; save lexer definition
Func _GUICtrlLex_SaveLexerDef()
	_HLP_Debug("... in _GUICtrlLex_SaveLexerDef()")
	_GUICtrlLex_GetFields()
	_GUICtrlLex_WriteLEXFile($__default_lexer)
	_GUICtrlLex_SetupStylingAndFolding()
	SendMessage($__hWnd_SciLexer, $SCI_COLOURISE, 0, -1)
EndFunc   ;==>_GUICtrlLex_SaveLexerDef

; reset lexer definition
Func _GUICtrlLex_ResetLexerDef()
	_GUICtrlComboBox_SetCurSel($frmLexDef, -1)
	_GUICtrlLex_ReadLEXFile()
	_GUICtrlLex_SetupStylingAndFolding()
	_GUICtrlLex_SetFields()
	_HLP_DisableButtons_Styles()
	_HLP_DisableButtons_Folds()
EndFunc   ;==>_GUICtrlLex_ResetLexerDef

; delete lexer definition file
Func _GUICtrlLex_DeleteLexerDef()
	Local $result = MsgBox(262180, __('Delete definition'), __('Do you really want to delete this definition? This can''t be undone!'), 0)
	Switch $result
		Case 6 ;YES
			FileDelete($__lexerdef & "\" & $__default_lexer & ".def")
			Local $m = _GUICtrlMenu_FindItem(GUICtrlGetHandle($__arM[1]), $__name)
			If $m <> -1 Then _GUICtrlMenu_RemoveMenu(GUICtrlGetHandle($__arM[1]), $m)
			_HLP_ListLexer()
			_GUICtrlLex_ResetLexerDef()
		Case 7 ;NO
	EndSwitch
EndFunc   ;==>_GUICtrlLex_DeleteLexerDef

; create new definition
Func _GUICtrlLex_CreateLexerDef()
	_HLP_Debug("... in _GUICtrlLex_SaveLexerDef()")
	Local $new = InputBox(__('New definition'), __('Please enter a unique definition ID.'), 'newdef', "", _
			Default, Default, Default, Default, 0, $frmLexDef)
	If $new <> "" Then
		If StringInStr($new, Chr(32)) <> 0 Then
			MsgBox(16, __("Error"), __('The definition ID contains space characters. This is not allowed!'), 0)
		Else
			If FileExists($__lexerdef & "\" & $new & ".def") Then
				MsgBox(16, __("Error"), __('The definition ID is already existing. Please choose another one!'), 0)
			Else
				GUICtrlSetData($inputLexerDesc, $new)
				_GUICtrlLex_GetFields()
				_GUICtrlLex_WriteLEXFile($new)
				_HLP_ListLexer()
				_GUICtrlComboBox_SetCurSel($cmbLanguage, _GUICtrlComboBox_FindStringExact($cmbLanguage, $new))
				$__default_lexer = $new
				Local $mi = GUICtrlCreateMenuItem($__name, $__arM[1])
				GUICtrlSetOnEvent(-1, "_GUICtrlLex_selectLexer")
				ReDim $__stylers_menu[UBound($__stylers_menu) + 1][2]
				$__stylers_menu[UBound($__stylers_menu) - 1][0] = $mi
				$__stylers_menu[UBound($__stylers_menu) - 1][1] = $__name
				_GUICtrlLex_SetupStylingAndFolding()
				SendMessage($__hWnd_SciLexer, $SCI_COLOURISE, 0, -1)
			EndIf
		EndIf
	EndIf
EndFunc   ;==>_GUICtrlLex_CreateLexerDef

; close lexer definition dialog
Func _GUICtrlLex_CloseLexerDefForm()
	_HLP_Debug("... in _GUICtrlLex_CloseLexerDefForm()")
	Opt("GUIOnEventMode", $__oldGUImode)
	GUISetState(@SW_HIDE, $frmLexDef)
	GUIDelete($frmLexDef)
EndFunc   ;==>_GUICtrlLex_CloseLexerDefForm

; create Scintilla editor component and set some handler defaults
; return scintilla handle
Func _GUICtrlLex_CreateScriptEditor($x = 0, $y = 0, $w = 500, $h = 400)
	_HLP_Debug("... in _GUICtrlLex_CreateScriptEditor()")
	; create scintilla component
	$__hWnd_SciLexer = Sci_CreateEditor($__default_editor_parent, $x, $y, $w, $h)
	_Resize_AddWindow($__hWnd_SciLexer, $GUI_DOCKBORDERS)

	; clear default bindings, will be handled in main while loop
	Sci_ClearCmdKey($__hWnd_SciLexer, 0x47, $SCMOD_CTRL);unbind the default ctrl+g action
	Sci_ClearCmdKey($__hWnd_SciLexer, 0x4E, $SCMOD_CTRL);unbind the default ctrl+n action
	Sci_ClearCmdKey($__hWnd_SciLexer, 0x4F, $SCMOD_CTRL);unbind the default ctrl+o action
	Sci_ClearCmdKey($__hWnd_SciLexer, 0x53, $SCMOD_CTRL);unbind the default ctrl+s action
	Sci_ClearCmdKey($__hWnd_SciLexer, 0x46, $SCMOD_CTRL);unbind the default ctrl+f action
	Sci_ClearCmdKey($__hWnd_SciLexer, 0x53, $SCMOD_SHIFT);unbind the default shift+s action
	Sci_ClearCmdKey($__hWnd_SciLexer, 0x46, $SCMOD_SHIFT);unbind the default shift+f action

	; register message and especially lexer handler
	_GUIRegisterMsg($WM_NOTIFY, "LEX_WM_NOTIFY")
	_GUIRegisterMsg($WM_COMMAND, "LEX_WM_COMMAND")
EndFunc   ;==>_GUICtrlLex_CreateScriptEditor
#endregion 1a Main functions

#region 1b Styler and Folder
; ------------------------------------------------------------------------------------------------------------------------
; --------------- LEXER MAIN ROUTINES ------------------------------------------------------------------------------------
; ------------------------------------------------------------------------------------------------------------------------

; main folder
Func _GUICtrlLex_FoldIt($pos = -1, $pos2 = -1)
	_HLP_Debug("... in _GUICtrlLex_FoldIt()")

	; called, if menu point is changed, but nothing in editor
	If $pos = 0 And $pos2 = 0 Then Return

	If Not $__fold And $__was_folded Then
		$__was_folded = False
		For $i = 0 To Sci_GetLineCount($__hWnd_SciLexer)
			_GUICtrlLexHlp_SetFoldLevel($i, $SC_FOLDLEVELBASE, 0)
		Next
		Return
	ElseIf Not $__fold Then
		Return
	EndIf
	
	$__was_folded = True
	
	; set to value of $__arFolding[<wordidx>][4] in LEX_WM_NOTIFY if a folding relevant keyword is found
	; -> if false, next newline is folder end
	; like sections with only a caption and a new line as ending
	; so we can check in _GUICtrlLex_FoldIt, if we have to handle folding differently (see $__arFolding(4))
	Local $closingtag = True

	; track blocks of single line comments
	Local $comments_end = False
	Local $comments_begin = False

	Local $p_start = 0, $p_end = 0, $lineCurrent = 0
	Local $parentLine, $endLine, $tPos, $aRet, $lineStartNext, $pos_alt, $comLine, $comLineLen
	Local $parent = False, $item, $ch, $chNext
	Local $foldPointFound, $visibleChars, $chPrev, $word
	Local $text, $tmp, $curMod, $nexMod, $style, $stylePrev, $styleNext, $position

	;#cs new folding
	If Not IsDeclared("pos") Or $pos = -1 Then
		$p_end = Sci_GetLength($__hWnd_SciLexer) ; recalc fold for the whole doc
	Else
		$lineCurrent = Sci_GetLineFromPos($__hWnd_SciLexer, $pos) ; get entry position of current line

		If $lineCurrent > 0 Then $lineCurrent -= 1 ; just correct for corrupted line problem

		;_HLP_Debug("-> line from entry position: " & $lineCurrent + 1)

		$parentLine = Sci_GetFoldParent($__hWnd_SciLexer, $lineCurrent) ; is -1 if no parent
		;_HLP_Debug("-> fold parent of entry line: " & $parentLine + 1)

		; show parent level and flag
		If $__HLP_Debug Then _GUICtrlLexHlp_GetFoldLevel($parentLine)

		; swap current line to parent as start
		If $parentLine = -1 Then
			;_HLP_Debug("-> ok, start folding from entry line")
		Else
			;_HLP_Debug("-> ok, start folding from parent line")
			$lineCurrent = $parentLine
			$parent = True
		EndIf
		
		; we need to get the whole block
		$endLine = Sci_GetLastChild($__hWnd_SciLexer, $parentLine, -1)
		If $endLine < Sci_GetLineCount($__hWnd_SciLexer) Then $endLine += 1
		;_HLP_Debug("-> (last child+1) from line " & $lineCurrent + 1 & " is " & $endLine + 1)

		$p_start = Sci_GetLineStartPos($__hWnd_SciLexer, $lineCurrent)

		If $pos2 <> -1 Then
			$p_end = $pos2
		Else
			$p_end = Sci_GetLineStartPos($__hWnd_SciLexer, $endLine) + Sci_GetLineLength($__hWnd_SciLexer, $endLine)
		EndIf

	EndIf
	;#ce

	If $p_start > $p_end Then Return ; can happen if line contains only @cr or @lf

	_HLP_Debug("-> folding from position " & $p_start & " (line " & $lineCurrent + 1 & ") to position " & $p_end & " (line " & $endLine + 1 & ") -> orig pos " & $pos & " pos2 " & $pos2)

	; set start level
	$aRet = _GUICtrlLexHlp_GetFoldLevel($lineCurrent) ; step back for correction
	$__levelCurrent = $aRet[0]
	$__levelNext = $__levelCurrent
	;_HLP_Debug("levelCurrent=levelNext to " & $__levelCurrent)

	; only care for the first word in line for folding
	$foldPointFound = False
	$visibleChars = 0
	$chPrev = ' '
	$chNext = Sci_GetChar($__hWnd_SciLexer, $p_start)
	$lineStartNext = Sci_GetLineStartPos($__hWnd_SciLexer, $lineCurrent + 1)
	$stylePrev = 0
	If $lineCurrent > 0 Then $stylePrev = Sci_GetStyleFirstWord($__hWnd_SciLexer, $lineCurrent - 1)
	$style = 0
	$styleNext = 0
	$comLineLen = StringLen($__charComLine)
	; main folding loop
	$position = $p_start
	While $position < $p_end
		; save last position
		$pos_alt = $position
		
		$ch = $chNext
		
		$chNext = Sci_GetChar($__hWnd_SciLexer, $position + 1)
		$style = Sci_GetStyleFirstWord($__hWnd_SciLexer, $lineCurrent)
		$styleNext = Sci_GetStyleFirstWord($__hWnd_SciLexer, $lineCurrent + 1)
		; make sure, we have some non-whitespace chars
		;If StringRegExp($ch,'\S',0) = 1 And StringRegExp($chNext,'\S',0) = 1 Then
		If StringRegExp($ch, '\S', 0) = 1 Then
			; get current word for word based folding comparison
			$word = Sci_GetWordFromPos($__hWnd_SciLexer, $position) ; normal word based on word characters
			If StringInStr($word, $ch) = 0 Then ; special char reached, GetWordFromPos returns old last word
				Local $word = ''
			EndIf
			;_HLP_Debug("-> word (normal search) found: " & $word)
			
			; now let's see, if single comment line is a word, a single char or a special character combination
			$comLine = ""
			If $word = $__charComLine then
				$comLine = $word
				$word = ""
			Else
				; get chars for comment line comparison
				Switch $comLineLen
					Case 1
						$comLine = $ch
					Case 2
						$comLine = $ch & $chNext
					Case Else
						$comLine = $ch & $chNext
						For $i = 2 to $comLineLen - 1
							$comLine &= Sci_GetChar($__hWnd_SciLexer, $position + $i)
						Next
				EndSwitch
			Endif
			
			; search folding array if we have found a foldpoint
			$item = -1
			If $comLine <> "" then $item = _ArraySearch($__arFolding, $comLine, -1, -1, 0, 0, 0, 0) ; first of all, is it a complete comment line
			If $item = -1 And $word <> "" Then $item = _ArraySearch($__arFolding, $word, -1, -1, 0, 0, 0, 0) ; normal word, so see if it's in the folding array
			If $item = -1 then $item = _ArraySearch($__arFolding, $ch, -1, -1, 0, 0, 0, 0) ; folding relevant single special character ( like } in C++, i .e)

			;_HLP_Debug("line " & $lineCurrent + 1 & ", position: " & $position & ", char: " & $ch & ", word: " & $word & ", item: " & $item )

			Select
				Case $item > -1 And $visibleChars = 0
					$visibleChars += 1
					Select
						Case $comLine = $__charComLine And $comLine <> ""
							If $__foldComment Then
								;_HLP_Debug("$stylePrev=" & $stylePrev)
								;_HLP_Debug("$style=" & $style)
								;_HLP_Debug("$styleNext=" & $styleNext)
								If $stylePrev <> $SCE_STYLE_COMMENTLINE And $style = $SCE_STYLE_COMMENTLINE And $styleNext = $SCE_STYLE_COMMENTLINE Then
									$foldPointFound = True
									$comments_begin = True
									$comments_end = False
									;_HLP_Debug("-> foldPoint, comments_end = false")
								ElseIf $stylePrev = $SCE_STYLE_COMMENTLINE And $style = $SCE_STYLE_COMMENTLINE And $styleNext <> $SCE_STYLE_COMMENTLINE Then
									$comments_begin = False
									$comments_end = True
									;_HLP_Debug("-> no foldPoint, comments_end = true")
								EndIf
								$position = $lineStartNext - 1; fast forward ;-)
							Else
								$position = $lineStartNext - 1; fast forward ;-)
							EndIf
						Case Else
							; general fold point found
							$foldPointFound = True
							
							; does it have a if...endif opening closing tag or is the
							; next empty newline the end?
							If Not $__arFolding[$item][4] Then $closingtag = False
							
							; has the line to have a special end word or char?
							If $__arFolding[$item][1] <> "" Then
								; get relevant line parts
								$text = Sci_GetLine($__hWnd_SciLexer, $lineCurrent)
								If $__charComLine <> "" Then
									$tmp = StringSplit($text, $__charComLine, 1) ; strip any comments from line
									$text = $tmp[1]
								EndIf
								$text = StringStripWS($text, 3) ; strip any whitespace characters
								$text = StringRight($text, StringLen($__arFolding[$item][1])) ; get last chars according to $__arFolding(1) definition
								; is ending of line as expected? if not, reset false-positive foldpoint
								If StringLower($text) <> StringLower($__arFolding[$item][1]) Then
									$item = -1
									$foldPointFound = False
									$position = $lineStartNext - 1; fast forward ;-)
								EndIf
							EndIf
					EndSelect
				Case $item > -1 And $visibleChars > 0 ; found behind other text in line, so ignore
					$item = -1
				Case Else ; we found a "normal" line, no special start or something
					If $comments_begin And $stylePrev = $SCE_STYLE_COMMENTLINE And $style <> $SCE_STYLE_COMMENTLINE Then $comments_end = True
					$visibleChars += 1
					$position = $lineStartNext - 1; fast forward ;-)
			EndSelect
		EndIf

		; special word found, let's see what to do
		If $foldPointFound Then
			$curMod = $__arFolding[$item][2] ; modifier for current level
			$nexMod = $__arFolding[$item][3] ; modifier for next level
			; special middle tag as beginning of foldering found -> treat as normal open tag
			; but ONLY if on first parent line -> then $parent = false!!!!
			If $parent And $curMod = -1 And $nexMod = 0 Then
				$curMod = 0
				$nexMod = 1
				$parent = False
			Else
				$parent = False
			EndIf
			;_HLP_Debug("-> FOLD POINT FOUND: " & $word & " (item: " & $item & ")")
			$__levelCurrent += $curMod
			;If $__levelCurrent < $SC_FOLDLEVELBASE then $__levelCurrent = $SC_FOLDLEVELBASE
			;_HLP_Debug("-> new levelCurrent: " & $__levelCurrent)
			$__levelNext += $nexMod
			;If $__levelNext < $SC_FOLDLEVELBASE then $__levelNext = $SC_FOLDLEVELBASE
			;_HLP_Debug("-> new levelNext: " & $__levelNext)
			$position = $lineStartNext - 1
		EndIf

		; only process at end of line
		If $position = $lineStartNext - 1 Then

			If $comments_end Then
				;$__levelCurrent -= 1
				$__levelNext -= 1
				$comments_end = False
			EndIf

			If $visibleChars = 0 Then ; no visible(!) chars in line
				;_HLP_Debug("-> no visible chars in line found")
				; if not closingtag then found a foldpoint relevant !!! EMPTY !!! newline, so decrease both levels as if we had a closing tag
				If Not $closingtag Then
					;_HLP_Debug("-> special char closing line found, descrease levels and reset")
					$__levelCurrent -= 1
					$__levelNext -= 1
					$closingtag = True ; assume we have ALWAYS a closing tag
				EndIf
				;_HLP_Debug("_GUICtrlLexHlp_SetFoldLevel(" & $lineCurrent + 1 & "," & $__levelCurrent & "," & $SC_FOLDLEVELWHITEFLAG & ")")
				If $__foldCompact Then
					_GUICtrlLexHlp_SetFoldLevel($lineCurrent, $__levelCurrent, $SC_FOLDLEVELWHITEFLAG)
				Else
					_GUICtrlLexHlp_SetFoldLevel($lineCurrent, $__levelCurrent)
				EndIf
			Else ; visible chars in line
				If $__levelCurrent < $__levelNext Then ; something has happened to foldeer hierarchy
					;_HLP_Debug("_GUICtrlLexHlp_SetFoldLevel(" & $lineCurrent + 1 & "," & $__levelCurrent & "," & $SC_FOLDLEVELHEADERFLAG & ")")
					_GUICtrlLexHlp_SetFoldLevel($lineCurrent, $__levelCurrent, $SC_FOLDLEVELHEADERFLAG)
				Else
					;_HLP_Debug("_GUICtrlLexHlp_SetFoldLevel(" & $lineCurrent + 1 & "," & $__levelCurrent & ")")
					_GUICtrlLexHlp_SetFoldLevel($lineCurrent, $__levelCurrent)
				EndIf
			EndIf

			$__levelCurrent = $__levelNext
			$visibleChars = 0
			$foldPointFound = False
			$lineCurrent += 1
			;$position = Sci_GetLineStartPos($__hWnd_SciLexer, $lineCurrent)
			$position = Sci_GetPosFirstWord($__hWnd_SciLexer, $lineCurrent)
			$lineStartNext = Sci_GetLineStartPos($__hWnd_SciLexer, $lineCurrent + 1)
			$chNext = Sci_GetChar($__hWnd_SciLexer, $position)
			$stylePrev = $style
			$style = $styleNext
		EndIf

		; last processed character
		;If $ch <> Chr(32) Then
		;	$chPrev = $ch
		;	$visibleChars += 1
		;EndIf

		; if lineCurrent is beyond EOF, then Sci_GetLineStartPos set $position to -1 ->allow normal exit
		;If $position = -1 or Asc($chNext) = 0 then $position = $p_end + 1
		If $position = -1 Then $position = $p_end + 1
		; go ahead, shift 1
		If $position = $pos_alt Then $position += 1
	WEnd
EndFunc   ;==>_GUICtrlLex_FoldIt

; main styler
Func _GUICtrlLex_StyleIt($pos = -1, $pos2 = -1)
	_HLP_Debug("... in _GUICtrlLex_StyleIt()")
	
	; called, if menu point is changed, but nothing in editor
	If $pos = 0 And $pos2 = 0 Then Return
	
	;_HLP_Debug("-> value of $__incomment:" & $__incomment)
	
	Local $wstart = 0
	Local $wstop = 0
	Local $textopener = ''
	Local $op, $op_prev, $op_next, $noop, $line, $endpos, $ch, $i, $i_alt, $comLine, $comLineLen
	Local $pos_alt, $word, $oldword, $return, $eol, $position

	; full restyling via F1
	If Not IsDeclared("pos") Or $pos = -1 Then
		Local $doclines = Sci_GetLineCount($__hWnd_SciLexer)
		Local $p_start = 0
		Local $p_end = Sci_GetLineStartPos($__hWnd_SciLexer, $doclines) + Sci_GetLineLength($__hWnd_SciLexer, $doclines)
	Else
		Local $p_start = $pos
		Local $p_end = $pos2
	EndIf

	_HLP_Debug("********** styling starts from position " & $p_start & " to position " & $p_end & "************")

	; first check if user wants to style
	; BUT, we always need to style, else Scintilla get's mad with SCN_STYLENEEDED
	If Not $__highlight Then
		Sci_StyleApply($__hWnd_SciLexer, $STYLE_DEFAULT, $p_start, $p_end)
		_HLP_Debug("highlighting deactivated...")
		Return
	EndIf
	
	; main styler loop
	$position = $p_start
	$op = Chr(10)
	$op_prev = Chr(13)
	$eol = -1
	$comLineLen = StringLen($__charComLine)
	While $position <= $p_end
		$noop = True ; special char found toggle
		
		; save last position and character
		$pos_alt = $position
		; correct $endpos variable, if necessary
		If $position + 1 > $endpos Then $endpos = $position + 1
		
		; see if we reached line end
		If $position > $eol Then
			;ProfileBlockStart("_GUICtrlLex_StyleIt: Get actual line and endpos")
			;_HLP_Debug("L:" & $line & " P:" & $position & " EOL:" & $eol)
			$line = Sci_GetLineFromPos($__hWnd_SciLexer, $position)
			$endpos = Sci_GetLineStartPos($__hWnd_SciLexer, $line + 1) - 1 ; whole line incl. @CR and/or @LF
			$eol = $endpos
			;ProfileBlockStop()
		EndIf

		; 0.) get chars around position
		$op_prev = Sci_GetChar($__hWnd_SciLexer, $position - 1)
		$op = Sci_GetChar($__hWnd_SciLexer, $position)
		$op_next = Sci_GetChar($__hWnd_SciLexer, $position + 1)
		
		; 0a.) and get chars for single comment line comparison
		Switch $comLineLen
			Case 0 
				$comLine = ""
			Case 1
				$comLine = $op
			Case 2
				$comLine = $op & $op_next
			Case Else
				$comLine = $op & $op_next
				For $i = 2 to $comLineLen - 1
					$comLine &= Sci_GetChar($__hWnd_SciLexer, $position + $i)
				Next
		EndSwitch
		
		; ---------------------------------------------------------------------------------
		; from now on the order of style processing is absolutely important to save time
		; and style the right things at the right time ;-))
		; i. e.  whole line is comment -> no need to style variables, etc.
		; ---------------------------------------------------------------------------------
		; 1.) first search for single chars/ comments / printing strings, etc
		; -> this can save whole lines from scanning and restyling!
		; -> saves time

		If Not $__incomment Then
			Select
				; catch NUL character
				Case Asc($op) = 0
					$position += 1
					; STYLING: block comment as in /*...*/
					; has to be in $__arBlockComments, but for block begin Mod()=0
				Case (_ArraySearch($__arBlockComments, ($op & $op_next)) <> -1) And Mod(_ArraySearch($__arBlockComments, ($op & $op_next)), 2) = 0
					Sci_StyleApply($__hWnd_SciLexer, $SCE_STYLE_COMMENTBLOCK, $position, $eol - $position) ;
					$position = $eol + 1
					$__incomment = True
					; STYLING: single comment line
				Case $comLine = $__charComLine And $comLine <> ""
					;ProfileBlockStart("_GUICtrlLex_StyleIt: Single comment line")
;					Sci_StyleApply($__hWnd_SciLexer, $SCE_STYLE_COMMENTLINE, $position, $eol - ($position + ($comLineLen - 1)))
					Sci_StyleApply($__hWnd_SciLexer, $SCE_STYLE_COMMENTLINE, $position, $eol - $position)
					$position = $eol + 1
					;ProfileBlockStop()
					; STYLING: numbers
				Case ($op = "0" Or Number($op) <> 0) And ($op_prev = "0" Or Number($op_prev) <> 0 Or $op_prev = Chr(32) Or _
						(_ObjDictSearch($__oOps, $op_prev) And Not @error) Or (_ObjDictSearch($__oBraces, $op_prev) And Not @error))
					;Case ($op = "0" Or Number($op) <> 0)
					;ProfileBlockStart("_GUICtrlLex_StyleIt: Numbers")
					Sci_StyleApply($__hWnd_SciLexer, $SCE_STYLE_NUMS, $position, 1)
					$position += 1
					;ProfileBlockStop()
					; STYLING: operator character
				Case _ObjDictSearch($__oOps, $op) And Not @error
					;ProfileBlockStart("_GUICtrlLex_StyleIt: Operator char")
					Sci_StyleApply($__hWnd_SciLexer, $SCE_STYLE_OPERATORS, $position, 1)
					$position += 1
					;ProfileBlockStop()
					; STYLING: braces
				Case _ObjDictSearch($__oBraces, $op) And Not @error
					;ProfileBlockStart("_GUICtrlLex_StyleIt: Braces")
					Sci_StyleApply($__hWnd_SciLexer, $SCE_STYLE_OPERATORS, $position, 1)
					$position += 1
					;ProfileBlockStop()
					; STYLING: text in ' ' or " "
				Case $op = $__quot Or $op = $__apostrophe
					;ProfileBlockStart("_GUICtrlLex_StyleIt: Text in quotes")
					$textopener = $op ; text has to be closed with which it was opened - don't close ' with " ;-)
					$ch = ''
					$i = $position + 1
					$i_alt = $position
					While $i <= $eol
						$ch = Sci_GetChar($__hWnd_SciLexer, $i)
						Select
							Case $ch = $__varMark And $__varNested
								Sci_StyleApply($__hWnd_SciLexer, $SCE_STYLE_TEXTINQUOTE, $i_alt, $i - $i_alt)
								$i = _GUICtrlLexHlp_VarsNested($i, $line)
								$i_alt = $i
							Case $ch = $__sysVarMark And $__sysVarNested
								Sci_StyleApply($__hWnd_SciLexer, $SCE_STYLE_TEXTINQUOTE, $i_alt, $i - $i_alt)
								$i = _GUICtrlLexHlp_SysVarsNested($i, $line)
								$i_alt = $i
							Case ($ch = $__constsMark Or $ch = $__constsEndMark) And $__constsNested
								Sci_StyleApply($__hWnd_SciLexer, $SCE_STYLE_TEXTINQUOTE, $i_alt, $i - $i_alt)
								$i = _GUICtrlLexHlp_ConstNested($i, $line)
								$i_alt = $i
							Case $ch = $textopener
								$endpos = $i + 1
								Sci_StyleApply($__hWnd_SciLexer, $SCE_STYLE_TEXTINQUOTE, $i_alt, $endpos - $i_alt)
								ExitLoop
							Case Else
								$i += 1
						EndSelect
					WEnd
					$position = $endpos
					;ProfileBlockStop()
					; STYLING: Sections [Sectionname]
				Case $op = $__sectOp And $__hasSects And Asc($op_next) > 32
					;ProfileBlockStart("_GUICtrlLex_StyleIt: Sections []")
					$ch = ''
					$i = $position + 1
					$i_alt = $position
					$ch = Sci_GetChar($__hWnd_SciLexer, $i_alt)
					While $i <= $eol
						Select
							Case $ch = $__sectOp
								Sci_StyleApply($__hWnd_SciLexer, $SCE_STYLE_SECTIONS, $i_alt, $i - $i_alt)
								$i = _GUICtrlLexHlp_SectionsNested($i_alt, $line)
								$i_alt = $i
							Case $ch = $__sectCl
								$endpos = $i + 1
								Sci_StyleApply($__hWnd_SciLexer, $SCE_STYLE_SECTIONS, $i_alt, $endpos - $i_alt)
								ExitLoop
							Case Asc($ch) < 33
								$endpos = $i
								Sci_StyleApply($__hWnd_SciLexer, $SCE_STYLE_SECTIONS, $i_alt, $endpos - $i_alt)
								ExitLoop
							Case Else
								$i += 1
						EndSelect
						$ch = Sci_GetChar($__hWnd_SciLexer, $i)
					WEnd
					$position = $endpos
					;ProfileBlockStop()
					; STYLING: Variables with special begin-end mark
				Case $op <> '' And $op = $__varMark And $position < $eol ; if $position = $eol then murks!!
					;ProfileBlockStart("_GUICtrlLex_StyleIt: Variables")
					$position = _GUICtrlLexHlp_VarsNested($position, $line)
					;ProfileBlockStop()
					; STYLING: System Variables with special begin-end mark
				Case $op <> '' And $op = $__sysVarMark And $position < $eol ; if $position = $eol then murks!!
					;ProfileBlockStart("_GUICtrlLex_StyleIt: System Variables")
					$position = _GUICtrlLexHlp_SysVarsNested($position, $line)
					;ProfileBlockStop()
				Case $op <> '' And $op = $__constsMark And $position < $eol ; if $position = $eol then murks!!
					;ProfileBlockStart("_GUICtrlLex_StyleIt: Constwords")
					$position = _GUICtrlLexHlp_ConstNested($position, $line)
					;ProfileBlockStop()
				Case Else
					;If $op = Chr(10) Or $op = Chr(13) Or $op = Chr(32) Then
					If Asc($op) < 33 And $op <> '' Then
						Sci_StyleApply($__hWnd_SciLexer, $STYLE_DEFAULT, $position, 1)
						$position += 1
					Else
						$noop = False
					EndIf
			EndSelect
			If $noop Then ContinueLoop
		EndIf
		
		; 2.) get word at position
		;ProfileBlockStart("_GUICtrlLex_StyleIt: Word from position...")
		$word = Sci_GetWordFromPos($__hWnd_SciLexer, $position)
		;ProfileBlockStop()
		;_HLP_Debug("StringInStr($word, $op): " & StringInStr($word, $op))
		If (StringInStr($word, $op) = 0 Or $word = @CRLF) And Not $__incomment Then ; special char reached, GetWordFromPos returns old last word, so fast forward
			$position += 1
			ContinueLoop
		EndIf
		
		#cs
			; some debugging output
			If $__HLP_Debug Then
			$oldword = $word
			If $word = '' Then
			Switch $op
			Case @CR
			$word = "<@CR>"
			Case Chr(10)
			$word = "<@LF>"
			Case @CRLF
			$word = "<@CRLF>"
			Case @TAB
			$word = "<@TAB>"
			Case Chr(32)
			$word = "<@SPACE>"
			EndSwitch
			EndIf
			_HLP_Debug("Position: " & $position & " -> Wort: " & $word & " (op=" & Asc($op) & ")")
			$word = $oldword ; reset if necessary ;-)
			EndIf
		#ce
		
		$word = StringLower($word)
		; 4.  now colour single but special words
		Select
			; STYLING: block comments (a) first, as we don't style any further inside
			; the next line can only come true, if the comment block marker consists of two special chars, as in /* ...*/
			; in that case, the comment block started in the section aboce and not here, but it ends here!!!
			Case (_ArraySearch($__arBlockComments, ($op & $op_next)) <> -1) And $__incomment
				$__incomment = False
				Sci_StyleApply($__hWnd_SciLexer, $SCE_STYLE_COMMENTBLOCK, $position, $eol - $position) ;
				$position = $eol + 1
				;ProfileBlockStop()
				; STYLING: block comments (b) first, as we don't style any further inside
			Case _ArraySearch($__arBlockComments, $word) <> -1
				;ProfileBlockStart("_GUICtrlLex_StyleIt: Block Comment Begin/End")
				If Mod(_ArraySearch($__arBlockComments, $word), 2) = 0 Then ; =0 => block begin / <> 0 => block end
					$__incomment = True
				Else
					$__incomment = False
				EndIf
				$return = Sci_GetWordPositions($__hWnd_SciLexer, $position)
				$wstart = $return[0]
				$wstop = $return[1]
				Sci_StyleApply($__hWnd_SciLexer, $SCE_STYLE_COMMENTBLOCK, $wstart, $wstop - $wstart) ;
				$position = $wstop
				;ProfileBlockStop()
				; STYLING: inside block comment
			Case $__incomment
				;ProfileBlockStart("_GUICtrlLex_StyleIt: Block Comment continue")
				$line = Sci_GetLineFromPos($__hWnd_SciLexer, $position)
				$wstart = Sci_GetLineStartPos($__hWnd_SciLexer, $line)
				$return = Sci_GetWordPositions($__hWnd_SciLexer, $position)
				$wstop = $return[1]
				Sci_StyleApply($__hWnd_SciLexer, $SCE_STYLE_COMMENTBLOCK, $wstart, $wstop - $wstart) ;
				$position = $wstop
				;ProfileBlockStop()
				; STYLING: Hex Nums
			Case StringRegExp($word, '(?i:^0x[0-9a-f]+$)') = 1
				;ProfileBlockStart("_GUICtrlLex_StyleIt: HexNums")
				$return = Sci_GetWordPositions($__hWnd_SciLexer, $position)
				$wstart = $return[0]
				$wstop = $return[1]
				Sci_StyleApply($__hWnd_SciLexer, $SCE_STYLE_NUMS, $wstart, $wstop - $wstart) ;
				$position = $wstop
				;ProfileBlockStop()
				; STYLING: Keywords
			Case _ObjDictSearch($__oKeywords, $word) And Not @error
				;ProfileBlockStart("_GUICtrlLex_StyleIt: Keywords")
				$return = Sci_GetWordPositions($__hWnd_SciLexer, $position)
				$wstart = $return[0]
				$wstop = $return[1]
				Sci_StyleApply($__hWnd_SciLexer, $SCE_STYLE_KEYWORDS, $wstart, $wstop - $wstart) ;
				$position = $wstop
				;ProfileBlockStop()
				; STYLING: Functions
			Case _ObjDictSearch($__oFuwords, $word) And Not @error
				;ProfileBlockStart("_GUICtrlLex_StyleIt: Functions")
				$return = Sci_GetWordPositions($__hWnd_SciLexer, $position)
				$wstart = $return[0]
				$wstop = $return[1]
				Sci_StyleApply($__hWnd_SciLexer, $SCE_STYLE_FUNCTIONS, $wstart, $wstop - $wstart) ;
				$position = $wstop
				;ProfileBlockStop()
				; STYLING: Reserved Words
			Case _ObjDictSearch($__oReswords, $word) And Not @error
				;ProfileBlockStart("_GUICtrlLex_StyleIt: Reserved Words")
				$return = Sci_GetWordPositions($__hWnd_SciLexer, $position)
				$wstart = $return[0]
				$wstop = $return[1]
				Sci_StyleApply($__hWnd_SciLexer, $SCE_STYLE_RESWORDS, $wstart, $wstop - $wstart) ;
				$position = $wstop
				;ProfileBlockStop()
				; STYLING: special constant
			Case _ObjDictSearch($__oConstwords, $word) And Not @error
				;ProfileBlockStart("_GUICtrlLex_StyleIt: Special constants")
				$return = Sci_GetWordPositions($__hWnd_SciLexer, $position)
				$wstart = $return[0]
				$wstop = $return[1]
				Sci_StyleApply($__hWnd_SciLexer, $SCE_STYLE_CONST, $wstart, $wstop - $wstart) ;
				$position = $wstop
				;ProfileBlockStop()
				; STYLING: additional words 1
			Case _ObjDictSearch($__oAdditional_1, $word) And Not @error
				;ProfileBlockStart("_GUICtrlLex_StyleIt: Additional words 1")
				$return = Sci_GetWordPositions($__hWnd_SciLexer, $position)
				$wstart = $return[0]
				$wstop = $return[1]
				Sci_StyleApply($__hWnd_SciLexer, $SCE_STYLE_ADD1, $wstart, $wstop - $wstart) ;
				$position = $wstop
				;ProfileBlockStop()
				; STYLING: additional words 2
			Case _ObjDictSearch($__oAdditional_2, $word) And Not @error
				;ProfileBlockStart("_GUICtrlLex_StyleIt: Additional words 2")
				$return = Sci_GetWordPositions($__hWnd_SciLexer, $position)
				$wstart = $return[0]
				$wstop = $return[1]
				Sci_StyleApply($__hWnd_SciLexer, $SCE_STYLE_ADD2, $wstart, $wstop - $wstart) ;
				$position = $wstop
				;ProfileBlockStop()
				; STYLING: system sections
			Case Not $__hasSects And _ObjDictSearch($__oSyssections, $word) And Not @error
				;ProfileBlockStart("_GUICtrlLex_StyleIt: System sections")
				$return = Sci_GetWordPositions($__hWnd_SciLexer, $position)
				$wstart = $return[0]
				$wstop = $return[1]
				Sci_StyleApply($__hWnd_SciLexer, $SCE_STYLE_SYSSECTIONS, $wstart, $wstop - $wstart) ;
				$position = $wstop
				;ProfileBlockStop()
				; STYLING: black for the rest
			Case Else
				;ProfileBlockStart("_GUICtrlLex_StyleIt: Black for the rest")
				; next line has one disadvantage: if you only add a " ", STYLENEEDED message will be sent continuosly
				If $word <> '' And $word <> " " And $word <> @TAB And Not $__incomment Then
					Local $return = Sci_GetWordPositions($__hWnd_SciLexer, $position)
					$wstart = $return[0]
					$wstop = $return[1]
					Sci_StyleApply($__hWnd_SciLexer, $STYLE_DEFAULT, $wstart, $wstop - $wstart) ;
					$position = $wstop
				EndIf
				;ProfileBlockStop()
		EndSelect
		; check if we have moved along, shift 1 if not
		If $position = $pos_alt Then $position += 1
	WEnd
EndFunc   ;==>_GUICtrlLex_StyleIt
#endregion 1b Styler and Folder

#region 2 Lexer helper functions
; ------------------------------------------------------------------------------------------------------------------------
; --------------- LEXER HELPER ROUTINES ----------------------------------------------------------------------------------
; ------------------------------------------------------------------------------------------------------------------------

; brace highlighting
Func _GUICtrlLexHlp_BraceHighlight($position)
	; if highlights existed before, remove them
	If $__oldbracepos[0] > -1 Then
		SendMessage($__hWnd_SciLexer, $SCI_BRACEHIGHLIGHT, -1, -1)
		$__oldbracepos[0] = -1
		$__oldbracepos[1] = -1
	EndIf
	
	; no brace, then out of here
	If _ArrayBinarySearch($__arBracematch, Sci_GetChar($__hWnd_SciLexer, $position)) = -1 Then Return
	
	; and now search for braces at cursor position
	Local $bracematch = SendMessage($__hWnd_SciLexer, $SCI_BRACEMATCH, $position, 0)
	If $bracematch <> -1 Then
		$__oldbracepos[0] = $position
		$__oldbracepos[1] = $bracematch
		SendMessage($__hWnd_SciLexer, $SCI_BRACEHIGHLIGHT, $position, $bracematch)
	Else
		$__oldbracepos[0] = $position
		$__oldbracepos[1] = -1
		SendMessage($__hWnd_SciLexer, $SCI_BRACEBADLIGHT, $position, -1)
	EndIf
EndFunc   ;==>_GUICtrlLexHlp_BraceHighlight

; handle nested variables
Func _GUICtrlLexHlp_VarsNested($posi, $line)
	;_HLP_Debug("... in _GUICtrlLexHlp_VarsNested()")

	Local $ch = ''
	;Local $line = Sci_GetLineFromPos($__hWnd_SciLexer, $posi)
	Local $epo = Sci_GetLineStartPos($__hWnd_SciLexer, $line + 1) - 1 ; get first position of next line, then step back 1 single position -> voil ;-)!
	For $j = $posi + 1 To $epo
		$ch = Sci_GetChar($__hWnd_SciLexer, $j)
		If Asc($ch) < 33 Or StringInStr($__charsForVars & $__varEndMark, $ch) = 0 Then
			$epo = $j
			If $ch = $__varEndMark Then $epo += 1
			ExitLoop
		EndIf
	Next
	Sci_StyleApply($__hWnd_SciLexer, $SCE_STYLE_VARIABLES, $posi, $epo - $posi)
	Return $epo
EndFunc   ;==>_GUICtrlLexHlp_VarsNested

; handle nested system variables
Func _GUICtrlLexHlp_SysVarsNested($posi, $line)
	;_HLP_Debug("... in _GUICtrlLexHlp_SysVarsNested()")

	Local $ch = ''
	;Local $line = Sci_GetLineFromPos($__hWnd_SciLexer, $posi)
	Local $epo = Sci_GetLineStartPos($__hWnd_SciLexer, $line + 1) - 1 ; get first position of next line, then step back 1 single position -> voil ;-)!
	For $j = $posi + 1 To $epo
		$ch = Sci_GetChar($__hWnd_SciLexer, $j)
		If Asc($ch) < 33 Or StringInStr($__charsForVars & $__sysVarEndMark, $ch) = 0 Then
			$epo = $j
			If $ch = $__sysVarEndMark Then $epo += 1
			ExitLoop
		EndIf
	Next
	Sci_StyleApply($__hWnd_SciLexer, $SCE_STYLE_SYSVARS, $posi, $epo - $posi)
	Return $epo
EndFunc   ;==>_GUICtrlLexHlp_SysVarsNested

; handle nested constants
Func _GUICtrlLexHlp_ConstNested($posi, $line)
	;_HLP_Debug("... in _GUICtrlLexHlp_ConstNested()")

	Local $ch = ''
	;Local $line = Sci_GetLineFromPos($__hWnd_SciLexer, $posi)
	Local $epo = Sci_GetLineStartPos($__hWnd_SciLexer, $line + 1) - 1 ; get first position of next line, then step back 1 single position -> voil ;-)!
	For $j = $posi + 1 To $epo
		$ch = Sci_GetChar($__hWnd_SciLexer, $j)
		If Asc($ch) < 33 Or $ch = $__constsEndMark Then
			$epo = $j
			If $ch = $__constsEndMark Then $epo += 1
			ExitLoop
		EndIf
	Next
	Sci_StyleApply($__hWnd_SciLexer, $SCE_STYLE_CONST, $posi, $epo - $posi)
	Return $epo
EndFunc   ;==>_GUICtrlLexHlp_ConstNested

; handle nested sections
Func _GUICtrlLexHlp_SectionsNested($posi, $line)
	;_HLP_Debug("... in _GUICtrlLexHlp_SectionsNested()")

	Local $ch = ''
	Local $text = ''
	;Local $line = Sci_GetLineFromPos($__hWnd_SciLexer, $posi)
	Local $epo = Sci_GetLineStartPos($__hWnd_SciLexer, $line + 1) - 1 ; get first position of next line, then step back 1 single position -> voil ;-)!
	For $j = $posi + 1 To $epo
		$ch = Sci_GetChar($__hWnd_SciLexer, $j)
		If Asc($ch) < 33 Or $ch = $__sectCl Then
			$epo = $j
			;If $ch = $__sectCl Then $epo -= 1
			ExitLoop
		Else
			$text &= $ch
		EndIf
	Next
	$text = StringSplit(StringLower($text), "_", 1) ; get first relevant part of section name
	If _ObjDictSearch($__oSyssections, $text[1]) Then
		Sci_StyleApply($__hWnd_SciLexer, $SCE_STYLE_SYSSECTIONS, $posi + 1, $epo - $posi)
	Else
		Sci_StyleApply($__hWnd_SciLexer, $SCE_STYLE_SECTIONS, $posi + 1, $epo - $posi)
	EndIf
	Return $epo
EndFunc   ;==>_GUICtrlLexHlp_SectionsNested

; wrapper for better debugging possibilities
Func _GUICtrlLexHlp_GetFoldLevel($lnr)
	Local $level
	$level = Sci_GetFoldLevel($__hWnd_SciLexer, $lnr)
	;_HLP_Debug("... in _GUICtrlLexHlp_GetFoldLevel(), in lnr: " & $lnr + 1 & ", level: " & $level[0] & ", flag: " & $level[1]) ; -1024 to see better what's going on
	Return $level
EndFunc   ;==>_GUICtrlLexHlp_GetFoldLevel

; wrapper for better debugging possibilities
Func _GUICtrlLexHlp_SetFoldLevel($lnr, $level = $SC_FOLDLEVELBASE, $flag = 0)
	;_HLP_Debug("... in _GUICtrlLexHlp_SetFoldLevel(), in lnr: " & $lnr + 1 & ", level " & $level) ; -1024 to see better what's going on
	Sci_SetFoldLevel($__hWnd_SciLexer, $lnr, BitOR($level, $flag))
EndFunc   ;==>_GUICtrlLexHlp_SetFoldLevel
#endregion 2 Lexer helper functions

#region 3 WM_HOOKS
; ------------------------------------------------------------------------------------------------------------------------
; ----------------- LEX_WM_COMMAND HOOK -----------------------------------------------------------------------------------
; ------------------------------------------------------------------------------------------------------------------------

Func LEX_WM_COMMAND($hWnd, $iMsg, $wParam, $lParam)
	Global $lastInputFocus
	Local $nNotifyCode = BitShift($wParam, 16)
	Local $nID = BitAND($wParam, 0x0000FFFF)

	Switch $nNotifyCode; Edit control event messages only
		Case $EN_SETFOCUS
			;If $lastInputFocus Then ConsoleWrite("-You previously had the cursor in Input control ID: " & $lastInputFocus & @crlf)
			;ConsoleWrite(@CRLF & '+Control ID      = ' & $nID & @crlf); control ID of Input edit control with focus
			;ConsoleWrite('+Control hWnd    = ' & $lParam & @crlf); handle of Input edit control with focus
			;ConsoleWrite('+ControlGetFocus = ' & ControlGetFocus($hWnd) & @crlf); the ClassNameNN of control 'Edit#'
			If $nID <> $lastInputFocus Then
				Global $lastInputFocus = $nID
			EndIf
		Case $CBN_SELCHANGE; Edit (Input) control has focus
			; only, if form is open ;-), check with $lstStyles
			If IsDeclared("frmLexDef") Then
				Switch $nID
					Case $cmbStBold
						If Not (GUICtrlRead($cmbStBold) = -1 And _
								$__selLstIdx = _GUICtrlListView_FindText($lstStyles, _ObjDictGetValue($__oStyleDict, $STYLE_DEFAULT))) Then
							_GUICtrlListView_SetItemText($lstStyles, $__selLstIdx, GUICtrlRead($cmbStBold), 3)
							_GUICtrlListView_ClickItem($lstStyles, $__selLstIdx)
						EndIf
					Case $cmbStItalic
						If Not (GUICtrlRead($cmbStItalic) = -1 And _
								$__selLstIdx = _GUICtrlListView_FindText($lstStyles, _ObjDictGetValue($__oStyleDict, $STYLE_DEFAULT))) Then
							_GUICtrlListView_SetItemText($lstStyles, $__selLstIdx, GUICtrlRead($cmbStItalic), 4)
							_GUICtrlListView_ClickItem($lstStyles, $__selLstIdx)
						EndIf
					Case $cmbStUnderline
						If Not (GUICtrlRead($cmbStUnderline) = -1 And _
								$__selLstIdx = _GUICtrlListView_FindText($lstStyles, _ObjDictGetValue($__oStyleDict, $STYLE_DEFAULT))) Then
							_GUICtrlListView_SetItemText($lstStyles, $__selLstIdx, GUICtrlRead($cmbStUnderline), 5)
							_GUICtrlListView_ClickItem($lstStyles, $__selLstIdx)
						EndIf
					Case $cmbStFontname
						If Not (GUICtrlRead($cmbStFontname) = -1 And _
								$__selLstIdx = _GUICtrlListView_FindText($lstStyles, _ObjDictGetValue($__oStyleDict, $STYLE_DEFAULT))) Then
							_GUICtrlListView_SetItemText($lstStyles, $__selLstIdx, GUICtrlRead($cmbStFontname), 6)
							_GUICtrlListView_ClickItem($lstStyles, $__selLstIdx)
						EndIf
					Case $cmbStFontsize
						If Not (GUICtrlRead($cmbStFontsize) = -1 And _
								$__selLstIdx = _GUICtrlListView_FindText($lstStyles, _ObjDictGetValue($__oStyleDict, $STYLE_DEFAULT))) Then
							_GUICtrlListView_SetItemText($lstStyles, $__selLstIdx, GUICtrlRead($cmbStFontsize), 7)
							_GUICtrlListView_ClickItem($lstStyles, $__selLstIdx)
						EndIf
					Case $cmbKeywordType
						Local $item = _GUICtrlListView_FindText($lstKeywords, GUICtrlRead($cmbKeywordType))
						_GUICtrlListView_SetItemSelected($lstKeywords, $item, True, True)
						_GUICtrlListView_ClickItem($lstKeywords, $item, "Primary", False, 2)
						GUICtrlSetData($edtWordList, "")
					Case $cmbLanguage
						_GUICtrlLex_ReadLEXFile(GUICtrlRead($cmbLanguage))
						_GUICtrlLex_SetupStylingAndFolding()
						_GUICtrlLex_SetFields()
						WinSetTitle($frmLexDef, "", "Lexer Definition: " & $__name)
						_HLP_DisableButtons_Styles()
						_HLP_DisableButtons_Folds()
				EndSwitch
			EndIf
		Case $EN_CHANGE ; general field change message, check field values
			If IsDeclared("inputVarMark") Then
				Switch $nID
					Case $inputVarMark, $inputVarEndMark, $inputSysVarMark, $inputSysVarEndMark, $inputConstMark, $inputConstEndMark, _
							$inputSectOpen, $inputSectClose, $inputQuot, $inputApo
						If StringLen(GUICtrlRead($nID)) > 1 Then
							Local $st = StringLeft(GUICtrlRead($nID), 1)
							GUICtrlSetData($nID, $st)
						EndIf
					;Case $inputSingleLineComment
					;	If StringLen(GUICtrlRead($nID)) > 2 Then
					;		Local $st = StringLeft(GUICtrlRead($nID), 1)
					;		GUICtrlSetData($nID, $st)
					;	EndIf
				EndSwitch
			EndIf
		Case $BN_CLICKED
			If IsDeclared("rdSectYes") Then
				Switch $nID
					Case $rdSectYes
						GUICtrlSetState($inputSectOpen, $gui_enable)
						GUICtrlSetState($inputSectClose, $gui_enable)
						GUICtrlSetState($chkIncSections, $gui_enable)
					Case $rdSectNo
						GUICtrlSetState($inputSectOpen, $gui_disable)
						GUICtrlSetState($inputSectClose, $gui_disable)
						GUICtrlSetState($chkIncSections, $gui_disable)
						_HLP_CheckSet($chkIncSections, False)
				EndSwitch
			EndIf
		Case $EN_KILLFOCUS; Edit (Input) control lost focus
			;$lastInputFocus = -1

			;use to reset comment once edit controls no longer have focus
			;ConsoleWrite('+$nID = ' & $nID & @CRLF); control ID of previous Input edit control with focus
			;ConsoleWrite('+ControlGetFocus = ' & ControlGetFocus($hWnd) & @CRLF); the ClassNameNN of control 'Edit#'
	EndSwitch

	Return $GUI_RUNDEFMSG
EndFunc   ;==>LEX_WM_COMMAND

; ------------------------------------------------------------------------------------------------------------------------
; ----------------- LEX_WM_NOTIFY HOOK -----------------------------------------------------------------------------------
; ------------------------------------------------------------------------------------------------------------------------

Func LEX_WM_NOTIFY($hWnd, $uMsg, $wParam, $lParam)
	Local $tNMHDR = DllStructCreate("hwnd hWndFrom;int IDFrom;int Code;", $lParam)
	Local $hWndFrom = HWnd(DllStructGetData($tNMHDR, "hWndFrom"))
	Local $iIDFrom = DllStructGetData($tNMHDR, "IDFrom")
	Local $iCode = DllStructGetData($tNMHDR, "Code")

	; first check normal messages and lex def form things apart from lexer specific
	If IsDeclared("lstStyles") Then
		Select
			Case $iCode = $LVN_COLUMNCLICK ; A column was clicked
				Local $tInfo = DllStructCreate($tagNMLISTVIEW, $lParam)
				Switch $wParam
					Case $lstStyles
					Case $lstFolds
					Case $lstKeywords
				EndSwitch
			Case $iCode = $NM_CLICK Or $iCode = $LVN_ITEMCHANGED
				Local $tInfo = DllStructCreate($tagNMITEMACTIVATE, $lParam)
				_HLP_Buttons($wParam)
				Switch $wParam
					Case $lstStyles
						$__selLstIdx = DllStructGetData($tInfo, "Index")
						;ConsoleWrite("MyProc- Styles: $NM_CLICK " & "-->Index: " & DllStructGetData($tInfo, "Index") & _
						;		"  -->SubItem: " & DllStructGetData($tInfo, "SubItem") & @CRLF)
						Local $items = _GUICtrlListView_GetItemTextArray($lstStyles, _GUICtrlListView_GetSelectionMark($lstStyles))
						If $items[1] <> "" Then
							; tune defaults to respect chosen font values
							Local $arDef = _HLP_GetStyleDefaults()
							Local $attrib = 0
							For $i = 4 To $arDef[0]
								If $items[$i] <> -1 Then $arDef[$i] = $items[$i]
							Next
							If $arDef[4] = 0 Then $arDef[4] = 400 ; normale font weight
							If $arDef[4] = 1 Then $arDef[4] = 700 ; bold font weight
							If $arDef[5] = 1 Then $attrib += 2 ; italic
							If $arDef[6] = 1 Then $attrib += 4 ; underline
							GUICtrlSetData($txtStName, $items[1] & ": The quick brown fox jumps over the lazy dog!")
							GUICtrlSetColor($txtStName, $items[2])
							GUICtrlSetBkColor($txtStName, $items[3])
							GUICtrlSetFont($txtStName, $arDef[8], $arDef[4], $attrib, $arDef[7])
							GUICtrlSetData($inputStText, StringTrimLeft($items[2], 2))
							GUICtrlSetData($inputStBG, StringTrimLeft($items[3], 2))
							GUICtrlSetData($cmbStBold, $items[4])
							GUICtrlSetData($cmbStItalic, $items[5])
							GUICtrlSetData($cmbStUnderline, $items[6])
							GUICtrlSetData($cmbStFontname, $items[7])
							GUICtrlSetData($cmbStFontsize, $items[8])
							GUICtrlSetColor($inputStText, $items[2])
							GUICtrlSetBkColor($inputStText, $items[2])
							GUICtrlSetColor($inputStBG, $items[3])
							GUICtrlSetBkColor($inputStBG, $items[3])
						EndIf
					Case $lstFolds
						;ConsoleWrite("MyProc - Folds: $NM_CLICK " & "-->Index: " & DllStructGetData($tInfo, "Index") & _
						;		"  -->SubItem: " & DllStructGetData($tInfo, "SubItem") & @CRLF)
						$__selLstIdx = DllStructGetData($tInfo, "Index")
						Local $items = _GUICtrlListView_GetItemTextArray($lstFolds, _GUICtrlListView_GetSelectionMark($lstFolds))
						If $items[1] <> "" Then
							GUICtrlSetData($inputFdKey, $items[1])
							GUICtrlSetData($inputFdEOL, $items[2])
							GUICtrlSetData($udsFdCurrent, $items[3])
							GUICtrlSetData($udsFdNext, $items[4])
							GUICtrlSetData($cmbFdCorr, $items[5])
						EndIf
					Case $lstKeywords
						;ConsoleWrite("MyProc - Keywords: $NM_CLICK " & "-->Index: " & DllStructGetData($tInfo, "Index") & _
						;						"  -->SubItem: " & DllStructGetData($tInfo, "SubItem") & @CRLF)
						$__selLstIdx = DllStructGetData($tInfo, "Index")
						Local $items = _GUICtrlListView_GetItemTextArray($lstKeywords, _GUICtrlListView_GetSelectionMark($lstKeywords))
						If $items[1] <> "" Then
							If StringInStr($items[1], "(") = 0 Then ; strip index count from type to not fill combo with invalid values
								GUICtrlSetData($cmbKeywordType, $items[1])
							Else
								Local $t = StringSplit($items[1], " ")
								GUICtrlSetData($cmbKeywordType, $t[1])
							EndIf
						EndIf
						GUICtrlSetData($edtWordList, $items[2])
				EndSwitch
		EndSelect

		Switch $hWndFrom
			Case GUICtrlGetHandle($lstStyles)
				Switch $iCode
					; special part for colouring the background of styles listview
					; basically, it takes the content of the listview subitem, and turns it into color ;-)
					; copied and modified from: http://www.autoitscript.com/forum/topic/138250-custom-drawn-treeviews-and-listviews/
					Case $NM_CUSTOMDRAW
						Local $tNMLVCUSTOMDRAW = DllStructCreate($tagNMLVCUSTOMDRAW, $lParam)
						Local $dwDrawStage = DllStructGetData($tNMLVCUSTOMDRAW, "dwDrawStage")
						
						Switch $dwDrawStage ; Holds a value that specifies the drawing stage
							
							Case $CDDS_PREPAINT
								; Before the paint cycle begins
								Return $CDRF_NOTIFYITEMDRAW ; Notify the parent window of any item-related drawing operations
								
							Case $CDDS_ITEMPREPAINT
								; Before painting an item
								Return $CDRF_NOTIFYSUBITEMDRAW ; Notify the parent window of any subitem-related drawing operations
								
							Case BitOR($CDDS_ITEMPREPAINT, $CDDS_SUBITEM)
								; Before painting a subitem
								Local $iSubItem = DllStructGetData($tNMLVCUSTOMDRAW, "iSubItem") ; Subitem index
								Switch $iSubItem
									Case 0
										; colourise keyword
										Local $dwItemSpec = DllStructGetData($tNMLVCUSTOMDRAW, "dwItemSpec") ; Item index
										;Local $hDC = DllStructGetData($tNMLVCUSTOMDRAW, "HDC")									; Handle to the item's device context
										;_WinAPI_SelectObject($hDC, $hLVfont)																		; Normal
										Local $fg = _GUICtrlListView_GetItemText($lstStyles, $dwItemSpec, 1)
										Local $bg = _GUICtrlListView_GetItemText($lstStyles, $dwItemSpec, 2)
										DllStructSetData($tNMLVCUSTOMDRAW, "ClrText", _HLP_ColorConvert($fg)) ; Forecolor of item text
										DllStructSetData($tNMLVCUSTOMDRAW, "ClrTextBk", _HLP_ColorConvert($bg)) ; Backcolor of subitem text
										;Case 1
										;; foreground
										;Local $dwItemSpec = DllStructGetData($tNMLVCUSTOMDRAW, "dwItemSpec")		; Item index
										;;Local $hDC = DllStructGetData($tNMLVCUSTOMDRAW, "HDC")									; Handle to the item's device context
										;;_WinAPI_SelectObject($hDC, $hLVfont)																		; Normal
										;Local $fg = _GUICtrlListView_GetItemText($lstStyles, $dwItemSpec, 1)
										;Local $bg = _GUICtrlListView_GetItemText($lstStyles, $dwItemSpec, 2)
										;DllStructSetData( $tNMLVCUSTOMDRAW, "ClrText", _HLP_ColorConvert($fg))		; Forecolor of item text
										;DllStructSetData( $tNMLVCUSTOMDRAW, "ClrTextBk", _HLP_ColorConvert($bg))	; Backcolor of subitem text
										;Case 2
										;; background
										;Local $dwItemSpec = DllStructGetData($tNMLVCUSTOMDRAW, "dwItemSpec")		; Item index
										;;Local $hDC = DllStructGetData($tNMLVCUSTOMDRAW, "HDC")									; Handle to the item's device context
										;;_WinAPI_SelectObject($hDC, $hLVfont)																		; Normal
										;Local $fg = _GUICtrlListView_GetItemText($lstStyles, $dwItemSpec, 1)
										;Local $bg = _GUICtrlListView_GetItemText($lstStyles, $dwItemSpec, 2)
										;DllStructSetData( $tNMLVCUSTOMDRAW, "ClrText", _HLP_ColorConvert($fg))		; Forecolor of item text
										;DllStructSetData( $tNMLVCUSTOMDRAW, "ClrTextBk", _HLP_ColorConvert($bg))	; Backcolor of subitem text
									Case Else
										DllStructSetData($tNMLVCUSTOMDRAW, "ClrText", 0x000000) ; Forecolor of (sub)item text
										DllStructSetData($tNMLVCUSTOMDRAW, "ClrTextBk", 0xFFFFFF) ; Backcolor of (sub)item text
								EndSwitch
								Return $CDRF_NEWFONT ; $CDRF_NEWFONT must be returned after changing font or colors
								
						EndSwitch
				EndSwitch
		EndSwitch
	EndIf
	; stop here, if document is still loading - NO LEXING routines for now...
	If $__lexRunning Then Return $GUI_RUNDEFMSG
	
	; now handle Scintilla messages
	Switch $hWndFrom
		Case $__hWnd_SciLexer
			Local $position = Sci_GetCurrentPos($__hWnd_SciLexer)
			$__currentLine = Sci_GetLineFromPos($__hWnd_SciLexer, $position)
			$__currentColumn = ($position - Sci_GetLineStartPos($__hWnd_SciLexer, $__currentLine)) + 1
			Switch DllStructGetData($tNMHDR, 3)
				Case $SCN_STYLENEEDED ; styler notification because of lexer = SCLEX_CONTAINER
					;ProfileBlockStart("SCN_STYLENEEDED")
					Local $tSCNotification = DllStructCreate($tagSCNotification, $lParam)
					Local $position = DllStructGetData($tSCNotification, 4)
					; style what's not styled
					Local $start_pos = Sendmessage($__hWnd_SciLexer, $SCI_GETENDSTYLED, 0, 0)
					Local $line_number = Sci_GetLineFromPos($__hWnd_SciLexer, $start_pos);
					Local $start_pos = Sci_GetLineStartPos($__hWnd_SciLexer, $line_number) ;
					_HLP_Debug("--------------------------------------")
					_HLP_Debug("SCN_STYLENEEDED")
					_HLP_Debug("from SC_GETENDSTYLED=" & $start_pos & " to tSCNotifiaction.position=" & $position)
					;					$__lexRunning = True
					_GUICtrlLex_StyleIt($start_pos, $position)
					_GUICtrlLex_FoldIt($start_pos, $position)
					;					$__lexRunning = True
					;ProfileBlockStop()
				Case $SCN_MODIFIED ; something happened, start restyling <- TOO OFTEN AND UNRELIABLE
					;ProfileBlockStart("SCN_MODIFIED")
					#cs
						Local $tSCNotification = DllStructCreate($tagSCNotification, $lParam)
						Local $position = DllStructGetData($tSCNotification, 4)
						Local $modtype = DllStructGetData($tSCNotification, 7); 2064 = Text gelscht, 1040=Text hinzugefgt
						Local $length = DllStructGetData($tSCNotification, 9); length of text change
						_HLP_Debug("--------------------------------------")
						_HLP_Debug("SCN_MODIFIED")
						_HLP_Debug("Notify: " & $modtype)
						If $modtype = 1040 Then
						; don't restyle here, just initiate message to Scintilla to send STYLENEEDED message ;-)
						_HLP_Debug("Text added from " & $position & " to " & $position + $length)
						EndIf
					#ce
					;ProfileBlockStop()
				Case $SCN_CHARADDED ; someone typed something, let's see if we have to do some special handling
					;ProfileBlockStart("SCN_CHARADDED")
					Local $tSCNotification = DllStructCreate($tagSCNotification, $lParam)
					Local $ch = Chr(DllStructGetData($tSCNotification, 5))
					Local $word = Sci_GetWordFromPos($__hWnd_SciLexer, $position)
					_HLP_Debug("--------------------------------------")
					_HLP_Debug("SCN_CHARADDED")
					_HLP_Debug("Word found: " & $word & " (char found: " & $ch & ") at position: " & $position)
					Switch $ch
						Case @LF ; align cursor to previous line via TABs
							Local $line = Sci_GetLineFromPos($__hWnd_SciLexer, $position)
							Local $prevLine = Sci_GetLine($__hWnd_SciLexer, $line - 1)
							If $prevLine <> "" Then
								Local $tabExp = ""
								Local $tabs = StringSplit($prevLine, @TAB)
								If $tabs[0] > 1 Then
									For $i = 1 To $tabs[0] - 1
										If Not $tabs[$i] = "" Then ExitLoop
										$tabExp &= @TAB
									Next
								EndIf
								Sci_AddLines($__hWnd_SciLexer, $tabExp, $line + 1)
								$position = Sci_GetLineStartPos($__hWnd_SciLexer, $line)
								If $tabs[0] > 1 Then SCI_SetCurrentPos($__hWnd_SciLexer, $position + StringLen($tabExp))
							EndIf
							; add your own ;-))
					EndSwitch
					#cs PERHAPS REUSABLE FOR CALLTIPS OR SO...
						; are there any folding relevant keywords or special chars?
						$item = -1
						if $word <> "" Then
						Local $item = _ArraySearch($__arFolding, $word, -1, -1, 0, 0, 0, 0)
						Else
						Local $item = _ArraySearch($__arFolding, $ch, -1, -1, 0, 0, 0, 0)
						Endif
						;If not @error or $ch = @LF then
						If $item <> -1 or $ch = @LF then
						_HLP_Debug("Initiate folding because of keyword: " & $word)
						Local $line = Sci_GetLineFromPos($__hWnd_SciLexer, $position)
						;_GUICtrlLex_FoldIt($position)
						EndIf
					#ce
					;ProfileBlockStop()
				Case $SCN_UPDATEUI
					;ProfileBlockStart("SCN_UPDATEUI")
					#cs
						_HLP_Debug("--------------------------------------")
						_HLP_Debug("SCN_UPDATEUI")
						_HLP_Debug("(Pos " & $position & ") Current line from cursor: " & $currentLine + 1)
					#ce
					; start brace search on keypress and (de-)highlight them
					_GUICtrlLexHlp_BraceHighlight(Sci_GetCurrentPos($__hWnd_SciLexer))
					;ProfileBlockStop()
				Case $SCN_MARGINCLICK
					;ProfileBlockStart("SCN_MARGINCLICK")
					Local $tSCNotification = DllStructCreate($tagSCNotification, $lParam)
					Local $position = DllStructGetData($tSCNotification, 4)
					Local $line_number = Sci_GetLineFromPos($__hWnd_SciLexer, $position)
					SendMessage($__hWnd_SciLexer, $SCI_TOGGLEFOLD, $line_number, 0)
					;ProfileBlockStop()
				Case $SCN_PAINTED ; colourise braces if found (occurs about every second)
					;ProfileBlockStart("SCN_PAINTED")
					; nothing
					;ProfileBlockStop()
				Case Else
					;ProfileBlockStart("SCN_???")
					#cs
						_HLP_Debug("--------------------------------------")
						_HLP_Debug("UNKNOWN Scintilla Notification: " & DllStructGetData($tNMHDR, 3))
						; 2013 = $SCN_PAINTED
						; 2007 = $SCN_UPDATEUI
					#ce
					;ProfileBlockStop()
			EndSwitch
		Case Else
			; some messages from other GUI elements
	EndSwitch

	Return $GUI_RUNDEFMSG
EndFunc   ;==>LEX_WM_NOTIFY
#endregion 3 WM_HOOKS

#region 4 Internal helper functions
; ----------------------------- HELPER -----------------------------------------------------------

; mark menu entry
Func _HLP_MarkMenuItem()
	If $__arM[0] <> 0 Then
		; uncheck previous selected styler
		For $i = 0 To UBound($__stylers_menu) - 1
			GUICtrlSetState($__stylers_menu[$i][0], $gui_unchecked)
		Next
		; find selected styler, load and check
		For $i = 0 To UBound($__stylers_menu) - 1
			If $__stylers_menu[$i][2] = $__name Then
				GUICtrlSetState($__stylers_menu[$i][0], $gui_checked)
				ExitLoop
			EndIf
		Next
	EndIf
EndFunc   ;==>_HLP_MarkMenuItem

; search word in keyword list
Func _HLP_search()
	_GUICtrlEdit_Find($edtWordList)
EndFunc   ;==>_HLP_search

; put available styler into Extras menu
Func _HLP_CreateLexerPickList($menu)
	Global $__stylers = _FileListToArray($__lexerdef, "*.def", 1)
	If Not IsArray($__stylers) Then
		Return
	EndIf
	For $hi = 1 To $__stylers[0]
		Local $mi = GUICtrlCreateMenuItem(IniRead($__lexerdef & "\" & $__stylers[$hi], "Basic", "name", ""), $menu, $hi)
		GUICtrlSetOnEvent(-1, "_GUICtrlLex_selectLexer")
		$__stylers_menu[UBound($__stylers_menu) - 1][0] = $mi ; menu item handle
		Local $t = StringSplit($__stylers[$hi], ".")
		$__stylers_menu[UBound($__stylers_menu) - 1][1] = $t[1] ; first part of filename, i. e. autoit_lex -> autoit_lex.def
		$__stylers_menu[UBound($__stylers_menu) - 1][2] = IniRead($__lexerdef & "\" & $__stylers[$hi], "Basic", "name", "") ; name as in ini file
		ReDim $__stylers_menu[UBound($__stylers_menu) + 1][3]
	Next
EndFunc   ;==>_HLP_CreateLexerPickList

; show some formatted debug messages
Func _HLP_Debug($dbg, $line = @ScriptLineNumber)
	If $__HLP_Debug Then
		Local $time = "[" & @MDAY & "." & @MON & "." & @YEAR & " " & @HOUR & ":" & @MIN & ":" & @SEC & "] ! DEBUG"
		If Not @Compiled Then
			ConsoleWrite(@CRLF & $time & " (" & $line & "): " & $dbg)
		EndIf
	EndIf
EndFunc   ;==>_HLP_Debug

; create and return dictionary from string or array
; string shoudln't be necessary any more, but who knows...
Func _HLP_CreateDict($var)
	Local $aTmp
	Local $oList = _ObjDictCreate()
	If IsArray($var) Then
		If $var[0] > 0 Then
			For $i = 1 To $var[0]
				$aTmp = StringSplit(StringLower($var[$i]), " ")
				For $j = 1 To $aTmp[0]
					_ObjDictAdd($oList, $aTmp[$j])
				Next
			Next
		EndIf
	Else
		$aTmp = StringSplit(StringLower($var), " ")
		For $j = 1 To $aTmp[0]
			_ObjDictAdd($oList, $aTmp[$j])
		Next
	EndIf
	Return $oList
EndFunc   ;==>_HLP_CreateDict

; reverse hex strings (by UEZ, http://www.autoitscript.com/forum/topic/134520-reverse-string-by-two-letter/#entry937884)
Func _HLP_HexStringReverse($HexString, $delim = " ") ;coded by UEZ 2011
	If Not IsString($HexString) Then Return SetError(1, 0, 0) ;not a string
	If StringRegExpReplace($HexString, "(?i)[0-9a-fs]", "") Then Return SetError(2, 0, 0) ;not a hex string
	Local $aResult = StringSplit($HexString, " ")
	If Not @error Then
		$aResult = StringSplit(StringRegExpReplace($HexString, "b([w])b", "0$1"), " ", 2)
	Else
		If Mod(StringLen($HexString), 2) Then $HexString = "0" & $HexString
		$aResult = StringRegExp($HexString, ".{2}", 3)
	EndIf
	_ArrayReverse($aResult)
	Return _ArrayToString($aResult, $delim)
EndFunc   ;==>_HLP_HexStringReverse

;RGB to BGR or BGR to RGB
Func _HLP_ColorConvert($iColor)
	Return BitOR(BitAND($iColor, 0x00FF00), BitShift(BitAND($iColor, 0x0000FF), -16), BitShift(BitAND($iColor, 0xFF0000), 16))
EndFunc   ;==>_HLP_ColorConvert

; color chooser for background color
Func _HLP_ChooseFGColor()
	Local $color = _ChooseColor(2, "0x" & GUICtrlRead($inputStText), 2, $frmLexDef)
	If $color <> -1 Then
		GUICtrlSetData($inputStText, $color)
		GUICtrlSetColor(StringTrimLeft($inputStText, 2), _HLP_GetComplementaryColor($color))
		GUICtrlSetBkColor($inputStText, $color)
		_GUICtrlListView_BeginUpdate($lstStyles)
		_GUICtrlListView_SetItemText($lstStyles, $__selLstIdx, $color, 1)
		_GUICtrlListView_EndUpdate($lstStyles)
		_GUICtrlListView_ClickItem($lstStyles, $__selLstIdx)
	EndIf
EndFunc   ;==>_HLP_ChooseFGColor

; color chooser for text color
Func _HLP_ChooseBGColor()
	Local $color = _ChooseColor(2, "0x" & GUICtrlRead($inputStBG), 2, $frmLexDef)
	If $color <> -1 Then
		GUICtrlSetData(StringTrimLeft($inputStBG, 2), $color)
		GUICtrlSetColor($inputStBG, _HLP_GetComplementaryColor($color))
		GUICtrlSetBkColor($inputStBG, $color)
		_GUICtrlListView_BeginUpdate($lstStyles)
		_GUICtrlListView_SetItemText($lstStyles, $__selLstIdx, $color, 2)
		_GUICtrlListView_EndUpdate($lstStyles)
		_GUICtrlListView_ClickItem($lstStyles, $__selLstIdx)
	EndIf
EndFunc   ;==>_HLP_ChooseBGColor

; rotate color component in degrees
Func _HLP_ColorShift($hue, $shift)
	$hue = Int($hue) + $shift
	If $hue >= 240 Then $hue -= 240
	If $hue < 0 Then $hue += 240
	Return $hue
EndFunc   ;==>_HLP_ColorShift

; return complementary color (with inverted lightness too)
Func _HLP_GetComplementaryColor($color)
	Local $arC = _ColorConvertRGBtoHSL(_ColorGetRGB($color))
	$arC[0] = _HLP_ColorShift($arC[0], 120)
	$arC[2] = _HLP_ColorShift($arC[2], 120)
	Return _ColorSetRGB(_ColorConvertHSLtoRGB($arC))
EndFunc   ;==>_HLP_GetComplementaryColor

; enable edit buttons for styles listview
Func _HLP_DisableButtons_Styles()
	GUICtrlSetState($inputStText, $gui_disable)
	GUICtrlSetState($inputStBG, $gui_disable)
	GUICtrlSetState($btnStText, $gui_disable)
	GUICtrlSetState($btnStBG, $gui_disable)
	GUICtrlSetState($cmbStBold, $gui_disable)
	GUICtrlSetState($cmbStItalic, $gui_disable)
	GUICtrlSetState($cmbStUnderline, $gui_disable)
	GUICtrlSetState($cmbStFontname, $gui_disable)
	GUICtrlSetState($cmbStFontsize, $gui_disable)
EndFunc   ;==>_HLP_DisableButtons_Styles

; disable edit buttons for styles listview
Func _HLP_EnableButtons_Styles()
	GUICtrlSetState($inputStText, $gui_enable)
	GUICtrlSetState($inputStBG, $gui_enable)
	GUICtrlSetState($btnStText, $gui_enable)
	GUICtrlSetState($btnStBG, $gui_enable)
	GUICtrlSetState($cmbStBold, $gui_enable)
	GUICtrlSetState($cmbStItalic, $gui_enable)
	GUICtrlSetState($cmbStUnderline, $gui_enable)
	GUICtrlSetState($cmbStFontname, $gui_enable)
	GUICtrlSetState($cmbStFontsize, $gui_enable)
EndFunc   ;==>_HLP_EnableButtons_Styles

; enable edit buttons for folds listview
Func _HLP_EnableButtons_Folds()
	GUICtrlSetState($inputFdKey, $gui_enable)
	GUICtrlSetState($inputFdEol, $gui_enable)
	GUICtrlSetState($udsFdCurrent, $gui_enable)
	GUICtrlSetState($udsFdNext, $gui_enable)
	GUICtrlSetState($cmbFdCorr, $gui_enable)
	GUICtrlSetState($btnFdAdd, $gui_enable)
	GUICtrlSetState($btnFdDel, $gui_enable)
	GUICtrlSetState($btnFdUpd, $gui_enable)
EndFunc   ;==>_HLP_EnableButtons_Folds

; disable edit buttons for folds listview
Func _HLP_DisableButtons_Folds()
	GUICtrlSetState($inputFdKey, $gui_disable)
	GUICtrlSetState($inputFdEol, $gui_disable)
	GUICtrlSetState($udsFdCurrent, $gui_disable)
	GUICtrlSetState($udsFdNext, $gui_disable)
	GUICtrlSetState($cmbFdCorr, $gui_disable)
	GUICtrlSetState($btnFdAdd, $gui_disable)
	GUICtrlSetState($btnFdDel, $gui_disable)
	GUICtrlSetState($btnFdUpd, $gui_disable)
EndFunc   ;==>_HLP_DisableButtons_Folds

; button DisEnAbler
Func _HLP_Buttons($control)
	Switch $control
		Case $lstStyles, $inputStText, $inputStBG
			_HLP_EnableButtons_Styles()
			_HLP_DisableButtons_Folds()
		Case $lstFolds, $inputFdKey, $inputFdEOL
			_HLP_DisableButtons_Styles()
			_HLP_EnableButtons_Folds()
		Case Else
			_HLP_DisableButtons_Styles()
			_HLP_DisableButtons_Folds()
	EndSwitch
EndFunc   ;==>_HLP_Buttons

; check/uncheck $field, $value only true/false!!!
Func _HLP_CheckSet($field, $value)
	If $value Then
		GUICtrlSetState($field, $gui_checked)
	Else
		GUICtrlSetState($field, $gui_unchecked)
	EndIf
EndFunc   ;==>_HLP_CheckSet

; get checked/unchecked statem, only true/false!!!
Func _HLP_CheckGet($field)
	If GUICtrlRead($field) = $gui_checked Then
		Return True
	Else
		Return False
	EndIf
EndFunc   ;==>_HLP_CheckGet

; write the content of keyword $variable under item $name to $lstView
Func _HLP_WriteKeywordsToListView($lView, $variable, $name)
	Local $id = _GUICtrlListView_GetItemCount($lView) - 1 ; need ZERO-based index
	If $variable[0] > 0 Then
		For $i = 1 To $variable[0]
			If $i = 1 Then
				_GUICtrlListView_AddItem($lView, $name)
			Else
				_GUICtrlListView_AddItem($lView, $name & " (" & $i & ")")
			EndIf
			$id += 1
			_GUICtrlListView_AddSubItem($lView, $id, $variable[$i], 1)
		Next
	Else
		_GUICtrlListView_AddItem($lView, $name)
		$id += 1
		_GUICtrlListView_AddSubItem($lView, $id, $variable[1], 1)
	EndIf
EndFunc   ;==>_HLP_WriteKeywordsToListView

; create keyword arrays based on category type
Func _HLP_GetKeywordsFromListView($lView, $name)
	Local $variable[2] = [0, "<no keywords defined for this category>"]
	Local $arTotal = _GUICtrlListView_CreateArray($lView)
	For $i = 1 To $arTotal[0][0]
		Local $t = StringSplit($arTotal[$i][0], " ")
		If $t[1] = $name Then ; basically we found at least one entry of the keyword specifier
			If $arTotal[$i][1] <> "<no keywords defined for this category>" Then
				Local $max = $variable[0] + 1
				ReDim $variable[$max + 1]
				$variable[0] = $max
				$variable[$max] = $arTotal[$i][1]
			EndIf
		EndIf
	Next
	Return $variable
EndFunc   ;==>_HLP_GetKeywordsFromListView

; get $STYLE_DEFAULT values and return as array
Func _HLP_GetStyleDefaults()
	Local $defidx = _GUICtrlListView_FindText($lstStyles, _ObjDictGetValue($__oStyleDict, $STYLE_DEFAULT))
	Local $arDef = _GUICtrlListView_GetItemTextArray($lstStyles, $defidx)
	If $arDef[0] > 0 Then
		Return $arDef
	Else
		Return -1
	EndIf
EndFunc   ;==>_HLP_GetStyleDefaults

; add folding criterium
Func _HLP_btnFdAdd()
	If IsArray($__arFoldingLV) Then
		ReDim $__arFoldingLV[UBound($__arFoldingLV) + 1][5]
	Else
		Global $__arFoldingLV[1][5]
	EndIf
	$__arFoldingLV[UBound($__arFoldingLV) - 1][0] = GUICtrlRead($inputFdKey)
	$__arFoldingLV[UBound($__arFoldingLV) - 1][1] = GUICtrlRead($inputFdEOL)
	$__arFoldingLV[UBound($__arFoldingLV) - 1][2] = GUICtrlRead($udsFdCurrent)
	$__arFoldingLV[UBound($__arFoldingLV) - 1][3] = GUICtrlRead($udsFdNext)
	$__arFoldingLV[UBound($__arFoldingLV) - 1][4] = GUICtrlRead($cmbFdCorr)
	_HLP_updListView($lstFolds, $__arFoldingLV)
	_GUICtrlListView_SetItemSelected($lstFolds, UBound($__arFoldingLV) - 1, True, True)
	_GUICtrlListView_ClickItem($lstFolds, UBound($__arFoldingLV) - 1, "Primary", False, 2)
EndFunc   ;==>_HLP_btnFdAdd

; update changes in folding criterium
Func _HLP_btnFdUpd()
	; if no folding definied yet, then don't update but add
	If Not IsArray($__arFoldingLV) Then
		_HLP_btnFdAdd()
		Return
	EndIf
	$__arFoldingLV[$__selLstIdx][0] = GUICtrlRead($inputFdKey)
	$__arFoldingLV[$__selLstIdx][1] = GUICtrlRead($inputFdEOL)
	$__arFoldingLV[$__selLstIdx][2] = GUICtrlRead($udsFdCurrent)
	$__arFoldingLV[$__selLstIdx][3] = GUICtrlRead($udsFdNext)
	$__arFoldingLV[$__selLstIdx][4] = GUICtrlRead($cmbFdCorr)
	_HLP_updListView($lstFolds, $__arFoldingLV)
	_GUICtrlListView_SetItemSelected($lstFolds, $__selLstIdx, True, True)
	_GUICtrlListView_ClickItem($lstFolds, $__selLstIdx, "Primary", False, 2)
EndFunc   ;==>_HLP_btnFdUpd

; delete folding criterium
Func _HLP_btnFdDel()
	If Not IsArray($__arFoldingLV) Then Return
	Local $rc = MsgBox(262436, __('Remove criterion'), __('Do you really want to remove this folding criterion?'), 0)
	Switch $rc
		Case 6 ;YES
			_ArrayDelete($__arFoldingLV, $__selLstIdx)
			If Not IsArray($__arFoldingLV) Then
				Local $__arFoldingLV[1][5] = [["<empty list>", "", 0, 0, True]]
			EndIf
			_HLP_updListView($lstFolds, $__arFoldingLV)
			Local $t = $__selLstIdx
			If $t > (UBound($__arFoldingLV) - 1) Then $t = UBound($__arFoldingLV) - 1
			_GUICtrlListView_SetItemSelected($lstFolds, $t, True, True)
			_GUICtrlListView_ClickItem($lstFolds, $t, "Primary", False, 2)
		Case 7 ;NO
			Return
	EndSwitch
EndFunc   ;==>_HLP_btnFdDel

; add keyword array
Func _HLP_btnKeyAdd()
	; edit field empty or only whitespace chars? then go back
	If StringStripWS(GUICtrlRead($edtWordList), 8) = "" Then Return
	
	Local $idx = $__selLstIdx
	Local $arTotal = _GUICtrlListView_CreateArray($lstKeywords)
	ReDim $arTotal[UBound($arTotal)][UBound($arTotal, 2) - 1] ; remove last column
	_ArrayDelete($arTotal, 0) ; we can't use the size information in first row
	If StringLen(GUICtrlRead($edtWordList)) > 4095 Then ; autoit doesn't store string vars greater than 4095 chars, so stop if field is larger
		MsgBox(262208, __('Update keyword list'), __('You cannot add more than 4095 characters to one entry. Please create a new list entry!'), 0)
	Else
		Local $words = StringReplace(GUICtrlRead($edtWordList), Chr(10), Chr(32))
		$words = StringReplace($words, Chr(13), Chr(32))
		$words = StringStripWS($words, 7)
		
		Local $kw = GUICtrlRead($cmbKeywordType)
		Local $arKW = _HLP_GetKeywordsFromListView($lstKeywords, $kw) ; get array with keywords of that category to see how much we have
		If $arKW[0] = 0 Then ; isn't there any entry yet, then just update from default field text
			$idx = _ArraySearch($arTotal, $kw)
			$arTotal[$idx][1] = $words
		Else ; ok, we have elements already, so we need to insert a new category line
			; first, find non matching category next to last line of matching row
			Local $comp = StringSplit($arTotal[$idx][0], " ")
			While ($comp[1] = $kw) And $idx < (UBound($arTotal) - 1)
				$idx += 1
				$comp = StringSplit($arTotal[$idx][0], " ")
			WEnd
			; if it is the last line in the listview, don't insert additional row before, but add below
			If $idx = (UBound($arTotal) - 1) And $comp[1] = $kw Then
				ReDim $arTotal[UBound($arTotal) + 1][UBound($arTotal, 2)]
				$idx = UBound($arTotal) - 1
			Else
				; insert additional row
				_2DArrayInsertRow($arTotal, $idx)
			EndIf
			; fill it
			$arTotal[$idx][0] = $kw & " (" & $arKW[0] + 1 & ")"
			$arTotal[$idx][1] = $words
		EndIf

		_HLP_updListView($lstKeywords, $arTotal)
		_GUICtrlListView_SetItemSelected($lstKeywords, $idx, True, True)
		_GUICtrlListView_ClickItem($lstKeywords, $idx, "Primary", False, 2)
	EndIf
EndFunc   ;==>_HLP_btnKeyAdd

; update wordlist in entry of keyword array
Func _HLP_btnKeyUpd()
	Local $arTotal = _GUICtrlListView_CreateArray($lstKeywords)
	ReDim $arTotal[UBound($arTotal)][UBound($arTotal, 2) - 1] ; remove last column
	_ArrayDelete($arTotal, 0) ; we can't use the size information in first row
	If StringLen(GUICtrlRead($edtWordList)) > 4095 Then ; autoit doesn't store string vars greater than 4095 chars, so stop if field is larger
		MsgBox(262208, __('Update keyword list'), __('You cannot add more than 4095 characters to one entry. Please create a new list entry!'), 0)
	Else
		Local $words = StringReplace(GUICtrlRead($edtWordList), Chr(10), Chr(32))
		$words = StringReplace($words, Chr(13), Chr(32))
		$words = StringStripWS($words, 7)

		$arTotal[$__selLstIdx][1] = $words
		_HLP_updListView($lstKeywords, $arTotal)
		_GUICtrlListView_SetItemSelected($lstKeywords, $__selLstIdx, True, True)
		_GUICtrlListView_ClickItem($lstKeywords, $__selLstIdx, "Primary", False, 2)
	EndIf
EndFunc   ;==>_HLP_btnKeyUpd

; delete entry from keyword array
Func _HLP_btnKeyDel()
	Local $rc = MsgBox(262436, __('Remove keyword'), __('Do you really want to remove this keyword category?'), 0)
	Switch $rc
		Case 7 ;NO
			Return
	EndSwitch
	Local $arTotal = _GUICtrlListView_CreateArray($lstKeywords)
	ReDim $arTotal[UBound($arTotal)][UBound($arTotal, 2) - 1] ; remove last column
	_ArrayDelete($arTotal, 0) ; we can't use the size information in first row

	Local $kw = StringSplit($arTotal[$__selLstIdx][0], " ")
	Local $arKW = _HLP_GetKeywordsFromListView($lstKeywords, $kw[1]) ; get array with keywords of that category to see how much we have
	If $arKW[0] = 0 Then Return ; nothing to delete
	If $arKW[0] = 1 Then ; only one entry, then just update from default field text
		$arTotal[$__selLstIdx][1] = "<no keywords defined for this category>"
	Else ; ok, we have elements, so we need to delete it and rewrite category texts in $arTotal
		_ArrayDelete($arTotal, $__selLstIdx) ; first, delete additional row
		Local $item = _ArraySearch($arTotal, $kw[1], 0, 0, 0, 1) ; second, find first row containing keyword category
		$arTotal[$item][0] = $kw[1] ; third, first row only category without counter
		; now search for all rows of the same category and update description
		$item += 1
		Local $i = 2
		While $item <= (UBound($arTotal) - 1) And (StringInStr($arTotal[$item][0], $kw[1]) <> 0)
			$arTotal[$item][0] = $kw[1] & " (" & $i & ")"
			$item += 1
			$i += 1
		WEnd
	EndIf
	
	_HLP_updListView($lstKeywords, $arTotal)
	_GUICtrlListView_SetItemSelected($lstKeywords, $__selLstIdx, True, True)
	_GUICtrlListView_ClickItem($lstKeywords, $__selLstIdx, "Primary", False, 2)
EndFunc   ;==>_HLP_btnKeyDel

; fill lstStyles
Func _HLP_SetStylesLV()
	_GUICtrlListView_DeleteAllItems(GUICtrlGetHandle($lstStyles))
	_GUICtrlListView_BeginUpdate($lstStyles)
	_GUICtrlListView_AddArray($lstStyles, $__arStyles)
	; convert decimal values to RGB for better readabilty
	; and set style names in column 0
	Local $fg, $bg, $st
	For $i = 0 To _GUICtrlListView_GetItemCount($lstStyles) - 1

		; column 0: lookup style names in dictionary
		$st = _GUICtrlListView_GetItemText($lstStyles, $i)
		$st = _ObjDictGetValue($__oStyleDict, Int($st))
		_GUICtrlListView_SetItemText($lstStyles, $i, $st, 0)

		; column 1+2: set foreground and background hex text value <- important, cause colors are set via LEX_WM_NOTIFY from field value
		; 1 - read decimal BGR value from subitem
		$fg = _GUICtrlListView_GetItemText($lstStyles, $i, 1)
		If $fg = -1 Then $fg = 0 ; white default
		$bg = _GUICtrlListView_GetItemText($lstStyles, $i, 2)
		If $bg = -1 Then $bg = 16777215 ; black default
		; 2 - the array values are dec BGR -> so calculate hex BGR, then reverse to RGB
		$fg = _HLP_HexStringReverse(Hex($fg, 6))
		$bg = _HLP_HexStringReverse(Hex($bg, 6))
		; 3 - construct '0xAABBCC' color code text
		$fg = "0x" & StringStripWS($fg, 8)
		$bg = "0x" & StringStripWS($bg, 8)
		; write to fields
		_GUICtrlListView_SetItemText($lstStyles, $i, $fg, 1)
		_GUICtrlListView_SetItemText($lstStyles, $i, $bg, 2)
		
	Next

	; size columns
	For $i = 1 To UBound($__arStyles, 2)
		_GUICtrlListView_SetColumnWidth($lstStyles, $i - 1, $LVSCW_AUTOSIZE_USEHEADER)
	Next
	_GUICtrlListView_EndUpdate($lstStyles)
EndFunc   ;==>_HLP_SetStylesLV

; reset ALL Styles to Default value
Func _HLP_btnStReset()
	; get styles
	Local $arDef = _HLP_GetStyleDefaults()
	For $i = 0 To _GUICtrlListView_GetItemCount($lstStyles) - 1
		If $__arStyles[$i][0] <> $STYLE_DEFAULT Then
			$__arStyles[$i][1] = $arDef[2]
			$__arStyles[$i][2] = $arDef[3]
			$__arStyles[$i][3] = -1
			$__arStyles[$i][4] = -1
			$__arStyles[$i][5] = -1
			$__arStyles[$i][6] = -1
			$__arStyles[$i][7] = -1
		EndIf
	Next
	_HLP_SetStylesLV()
EndFunc   ;==>_HLP_btnStReset

; update listviews (delete all elements and set them again)
Func _HLP_updListView($_control, $_array)
	_GUICtrlListView_BeginUpdate($_control)
	_GUICtrlListView_DeleteAllItems(GUICtrlGetHandle($_control))
	_GUICtrlListView_AddArray($_control, $_array)
	For $i = 1 To UBound($_array, 2)
		_GUICtrlListView_SetColumnWidth($_control, $i - 1, $LVSCW_AUTOSIZE_USEHEADER)
	Next
	_GUICtrlListView_EndUpdate($_control)
EndFunc   ;==>_HLP_updListView

; put available styler into Extras menu
Func _HLP_ListLexer()
	Local $name, $st = ""
	Global $__stylers = _FileListToArray($__lexerdef, "*.def", 1)
	If Not IsArray($__stylers) Then
		Return
	EndIf
	For $i = 1 To $__stylers[0]
		$name = StringSplit($__stylers[$i], ".")
		$st &= $name[1] & "|"
	Next
	GUICtrlSetData($cmbLanguage, "")
	GUICtrlSetData($cmbLanguage, StringTrimRight($st, 1), $__default_lexer)
EndFunc   ;==>_HLP_ListLexer
#endregion 4 Internal helper functions
