#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Run_AU3Check=n
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
Opt("GUIOnEventMode", 1)

#include "_LexingUDF.au3"

Example()

; example
Func Example()
    Local $msg

    $hGUI = GUICreate("My GUI - type in some AutoIt Code ;-))",1024,768) ; will create a dialog box that when displayed is centered
	Global $mFile = GUICtrlCreateMenu("File")
	Global $mOpen = GUICtrlCreateMenuItem("Open", $mFile)
	Global $mQuit = GUICtrlCreateMenuItem("Quit", $mFile)
	_GUICtrlLex_CreateLexerDefMenu('main')

	#region scintilla_setup
	; setup parent for controls
	$__default_editor_parent = $hGUI
	; load startup styling definition
	_GUICtrlLex_ReadLEXFile("autoit")
	; create Scintilla component and setup some key sequences
	_GUICtrlLex_CreateScriptEditor(0, 0, 1024, 768)
	; setup everything else for styling
	_GUICtrlLex_SetupStylingAndFolding()
	#endregion

	GUISetOnEvent($GUI_EVENT_CLOSE, "Quit", $hGUI)
	GUICtrlSetOnEvent($mQuit, "Quit")
	GUICtrlSetOnEvent($mOpen, "OpenFile")
	GUICtrlSetOnEvent($__arM[2], "_GUICtrlLex_OpenLexerDef")

    GUISetState(@SW_SHOW)

    While 1
		Sleep(100)
	Wend
	
EndFunc   ;==>Example1

; open a file for editing

Func OpenFile()
	$_FILENAME = FileOpenDialog("Open file...", "", $__filetypes, 3, "", $__default_editor_parent)
	If $_FILENAME = '' Then
		Return
	EndIf
		
	Local $file = FileOpen($_FILENAME, 0)
	; Check if file opened for reading OK
	If $file = -1 Then
		MsgBox(262160, "Error", "Error: Unable to open file.", 0)
		Return
	EndIf

	Sci_DelLines($__hWnd_SciLexer)
	Sci_EmptyUndoBuffer($__hWnd_SciLexer)
	Sci_SetSavePoint($__hWnd_SciLexer)

	Sci_Cancel($__hWnd_SciLexer)
	Sci_SetUndoCollection($__hWnd_SciLexer, 0)

	$__lexRunning = True
	While 1
		;$buffer = FileRead($file, 1024)
		Local $buffer = FileRead($file, 4095)
		If @error = -1 Then ExitLoop
		Sci_AppendText($__hWnd_SciLexer, StringReplace($buffer, Chr(0), ""))
	WEnd
	FileClose($file)
	Sci_SetUndoCollection($__hWnd_SciLexer)
	Sci_EmptyUndoBuffer($__hWnd_SciLexer)
	Sci_SetSavePoint($__hWnd_SciLexer)
	Sci_SetCurrentPos($__hWnd_SciLexer, 0)
	; send message to recolourise the whole text once
	_GUICtrlLex_StyleIt()
	_GUICtrlLex_FoldIt()

	Sci_SetSelection($__hWnd_SciLexer, -1, -1)
	Sci_GotoLine($__hWnd_SciLexer, 0)
	$__lexRunning = False
EndFunc   ;==>OpenFile

Func Quit()
	Exit
EndFunc